var globalData = {
  'prod': {
    'openAPIHost': '',
  },
  'qa': {
    'openAPIHost': '',
  },
  'dev': {
    'openAPIHost': 'http://192.168.0.28:9000',
  },
  hostname: location.hostname,
  tty: 1,
  isImage: true,
  languagemap: {},
  hashName: location.href.split("#")[1],
  language: [{
      lang: '简体中文',
      type: 'cn',
    },
    {
      lang: 'English',
      type: 'en',
    },
    {
      lang: '繁体中文',
      type: 'tc',
    }
  ]
}
var urlSearchParams = new URLSearchParams(window.location.search);
// 把键值对列表转换为一个对象
var url_params = Object.fromEntries(urlSearchParams.entries());
var url_lang = '';
for (let i = 0; i < globalData.language.length; i++) {
  let langInfo = globalData.language[i];
  if (url_params.l == langInfo.lang) {
    url_lang = langInfo.type;
  }
}

var socket = null;

function closeSocket() {
  if (socket) {
    term.reset();
    socket.close();
  }
}

function showLoading() {
  $('#jv-docker_loading').show();
}

function hideLoading() {
  $('#jv-docker_loading').hide();
}

function postData(obj, fn, showLoding) {

  if (showLoding) {
    showLoading();
  }

  fn = fn || {};
  obj = obj || {};
  $.ajax({
    url: obj.url, //接口
    type: obj.type == undefined ? 'post' : obj.type, //GET或POST
    data: obj.data == undefined ? '' : obj.data,
    dataType: 'json',
    contentType: 'application/json',
    success: function(result) {
      if (typeof fn.success === 'function') {
        fn.success(result);
      }

    },
    complete: function(event, xhr, options) {
      if (showLoding) {
        hideLoading();
      }
      if (typeof fn.complete === 'function') {
        fn.complete(event, xhr, options);
      }

    },
    error: function(xhr, textStatus) {
      if (xhr.status == 401) {
        location.href = 'login.html?v=' + new Date().getTime() + '&t=' + url_params.t + '&l=' + url_params.l + '&u=' + url_params.u + '&p=' + url_params.p;
      }

      if (xhr.status == 500) {
        errorMessageBox(xhr.responseJSON.message);
      }

      if (typeof fn.error === 'function') {
        if (xhr.responseJSON) {
          errorMessageBox(xhr.responseJSON.message);
        }
        fn.error(xhr, textStatus);
      }

    }
  });

}

function loadlanguage(lang) {
  lang = lang || 'cn';

  $.i18n.properties({ //加载资浏览器语言对应的资源文件
    name: lang, //资源文件名称
    path: 'language/', //资源文件路径
    language: lang,
    cache: false,
    mode: 'map', //用Map的方式使用资源文件中的值
    callback: function() { //加载成功后设置显示内容
      globalData.languagemap = $.i18n.map;
    }
  });
}

//语言切换
function changeLanguage(langName) {
  for (let i in globalData.languagemap) {
    $('[data-lang="' + i + '"]').text(globalData.languagemap[i]);
    if ($('[data-lang="' + i + '"]').attr('title') != 'no') {
      $('[data-lang="' + i + '"]').attr('title', globalData.languagemap[i]);
    } else {
      $('[data-lang="' + i + '"]').removeAttr('title');
    }
    $('input[data-lang="' + i + '"]').attr('placeholder', globalData.languagemap[i]);
  }
}

function _(s) {
  for (let i in globalData.languagemap) {
    if (s == i) {
      return globalData.languagemap[i];
      break;
    }
  }
  return '';
}

function isMobile() {
  if (/AppleWebKit.*Mobile/i.test(navigator.userAgent) ||
    /huawei/i.test(navigator.userAgent) ||
    /iPhone/i.test(navigator.userAgent) ||
    /Android/i.test(navigator.userAgent) ||
    /BlackBerry/i.test(navigator.userAgent) ||
    /IEMobile/i.test(navigator.userAgent) ||
    (/MIDP|SymbianOS|NOKIA|SAMSUNG|LG|NEC|TCL|Alcatel|BIRD|DBTEL|Dopod|PHILIPS|HAIER|LENOVO|MOT-|Nokia|SonyEricsson|SIE-|Amoi|ZTE/.test(navigator.userAgent))) {
    return true;
  } else {
    return false;
  }
}
