
(function() {
  'use strict'

  spaRouters.beforeEach(function(transition) {
    setTimeout(function() {
      //模拟切换之前延迟，比如说做个异步登录信息验证
      transition.next();
    }, 10)
  })
  spaRouters.afterEach(function(transition) {})
  spaRouters.init();

})();

// 选择语言
function showLanguageType() {
  $('#jv-languageList').slideToggle();
}

$('#jv-languageList li a').click(function() {
  var eg = $(this).attr('data-type');
  loadlanguage(eg);
  changeLanguage(eg);
  $('#jv-languageList').slideUp();
  $('#jv-languageType').text($(this).text()).attr('class', 'languageSelect ' + eg);
  $(this).addClass('currentLanguage').parent().siblings().find('a').removeClass('currentLanguage');
  localStorage.setItem('lang', eg);
})

function setLanguageType() {
  let lang = url_lang || localStorage.getItem('lang');
  if (lang == undefined || lang == '' || lang == null) {
    lang = 'cn';
  }
  $('#jv-languageList li a').each(function(i, e) {
    if (lang == $(e).attr('data-type')) {
      $(e).addClass('currentLanguage');
      $('#jv-languageType').text($(e).text()).attr('class', 'languageSelect ' + lang);
    } else {
      $(e).removeClass('currentLanguage');
    }
  });

}
//右边用户下拉框显示
function showUserOperation() {
  $('#jv-userOperation').slideToggle();
}

//退出
function signOut() {
  document.cookie = "docker=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;";
  location.href = 'login.html';
}

function getDefaultLang() {
  var lang = navigator.language || navigator.userLanguage; //常规浏览器语言和IE浏览器
  lang = lang.substr(0, 2); //截取lang前2位字符
  return lang;
}


$('#jv-myAccount').click(function(e) {
  let t = $(e.currentTarget);
  let i = $(e.currentTarget).index();
  $('#jv-headerTitle').text(t.find('a').text());
})

function navswitch(){
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  event.stopPropagation();
  $('#jv-navContainer').fadeIn();

  $(document).on('click', function(e){
    e.stopPropagation();
    $('#jv-navContainer').fadeOut();
  })
}

$(document).ready(function() {

  let lang = url_lang || localStorage.getItem('lang');
  loadlanguage(lang);

  changeLanguage(lang);
  setLanguageType();

  let userInfo = {};

  if(sessionStorage.getItem('userInfo') == undefined){
    userInfo = {}
  }else {
     userInfo = JSON.parse(sessionStorage.getItem('userInfo') || {});
  }

  $('#jv-userName').text(userInfo.username);

})
