//注册
function registerAcc() {
  $('#jv-login').hide();
  $('#jv-reg').show();
}
//已有账户
function existingAcc() {
  $('#jv-login').show();
  $('#jv-reg').hide();
}
pubkey = "";

var url_lang = '';
for (let i = 0; i < globalData.language.length; i++) {
  let langInfo = globalData.language[i];
  if (url_params.l == langInfo.lang) {
    url_lang = langInfo.type;
  }
}

//获取公钥
function get_pubkey() {
  var data = {
    action: "get_public_key"
  }

  let obj = {
    url: '../../desktop/includes/login.php',
    data: JSON.stringify(data),
  }

  postData(obj, {
    complete: function(result) {
      if (result) {
        pubkey = result.responseText;
      }
    }
  });
}

function check_token() {
  var data = {
    cmd: "docker_auth",
    token: getCookie('PHPSESSID') || url_params.t,
    params: {
      type: "token"
    }
  }

  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data),
  }

  postData(obj, {
    success: function(result) {

      if (result.err == 0) {
        $('#jv-container-fluid').hide();
        if (isMobile()) {
          location.href = 'm.index.html?v=' + new Date().getTime() + '&t='+url_params.t+'&l='+url_params.l+'&u='+url_params.u+'&p='+url_params.p;
        }else {
          location.href = 'index.html?v=' + new Date().getTime();
        }
        sessionStorage.setItem('userInfo', JSON.stringify({
          username: username
        }));
      } else {
        get_pubkey();
        $('#jv-container-fluid').show();
      }

    },
    error: function(xhr, textStatus) {
      // if NOT logged-in in unas desktop
      get_pubkey();
      $('#jv-container-fluid').show();
    }
  });
}

check_token();

//登录
function goLogin() {
  var username = $('#jv-username').val();
  var password = $('#jv-password').val();

  if (username == '') {
    errorMessageBox('请输入用户名！');
    return;
  }

  if (password == '') {
    errorMessageBox('请输入密码！');
    return;
  } else {
    var encrypt = new JSEncrypt();
    encrypt.setPublicKey(pubkey);
    password = encrypt.encrypt(password);
  }

  var data = {
    cmd: "docker_auth",
    token: getCookie('PHPSESSID'),
    params: {
      type: "pass",
      username: username,
      password: password
    }
  }

  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data),
  }

  postData(obj, {
    success: function(result) {
      if (result.err == 0) {
        if (isMobile()) {
          location.href = 'm.index.html?v=' + new Date().getTime() + '&t='+url_params.t+'&l='+url_params.l+'&u='+url_params.u+'&p='+url_params.p;
        }else {
          location.href = 'index.html?v=' + new Date().getTime();
        }
        sessionStorage.setItem('userInfo', JSON.stringify({
          username: username
        }));
      } else if (result.err == 9988) {
        errorMessageBox('没有访问权限或用户名密码错误');
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
      if (xhr.status == 422) {
        if (xhr.responseJSON.message == "Invalid credentials") {
          errorMessageBox('用户名或密码错误！');
        }
      }
    }
  });

}

//注册
function initAdmin() {
  sessionStorage.setItem('unasDocker', '');
  var username = $('#jv-zcName').val();
  var password = $('#jv-zcPssword').val();
  var cdPassword = $('#jv-cdPassword').val();

  // if (username === password) {
  //   errorMessageBox('请输入用户名和密码！');
  //   return;
  // }

  if (username == '') {
    errorMessageBox('请输入用户名！');
    return;
  }

  if (password == '') {
    errorMessageBox('请输入密码！');
    return;
  }
  if (password != cdPassword) {
    errorMessageBox('两次密码输入不一样！');
    return;
  }

  var data = {
    Username: username,
    Password: password
  }

  let obj = {
    url: '../api/users/admin/init',
    data: JSON.stringify(data),
  }

  postData(obj, {
    success: function(result) {
      if (result) {

      }

    },
    complete: function(xhr, options) {
      if (xhr.status == 200) {

        let dataZc = {
          username: username,
          password: password
        }

        let obj = {
          url: '../api/auth',
          data: JSON.stringify(dataZc),
        }

        postData(obj, {
          success: function(result) {
            if (result) {
              sessionStorage.setItem('userInfo', JSON.stringify({
                username: username
              }));
              settings();
            }

          },
          error: function(xhr, textStatus) {
            console.log(xhr);
            console.log(textStatus);
          }
        });



      } else {

      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

function settings() {
  let data = {
    enableTelemetry: true
  }

  let obj = {
    url: '../api/settings',
    data: JSON.stringify(data),
    type: 'put'
  }

  postData(obj, {
    success: function(result) {
      if (result) {

      }

    },
    complete: function(xhr, options) {
      if (xhr.status == 200) {
        endpoints();
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}

function endpoints() {

  var formData = new FormData();

  formData.append("Name", "local");
  formData.append("EndpointCreationType", 1);
  formData.append("URL", "");
  formData.append("PublicURL", "");
  formData.append("GroupID", "");
  formData.append("TagIds", []);
  formData.append("TLS", false);

  var request = new XMLHttpRequest();
  request.open("POST", "../api/endpoints");

  request.onreadystatechange = function() {
    if (request.readyState === XMLHttpRequest.DONE && request.status === 200) {
      if (isMobile()) {
        location.href = 'm.index.html?v=' + new Date().getTime() + '&t='+url_params.t+'&l='+url_params.l+'&u='+url_params.u+'&p='+url_params.p;
      }else {
        location.href = 'index.html?v=' + new Date().getTime();
      }
    }
  }
  request.send(formData);
}
document.onkeydown = function(event) {
  var e = event || window.event || arguments.callee.caller.arguments[0];
  if (e && e.keyCode == 13) { // enter 键
    if ($('#jv-reg').is(':hidden')) {
      goLogin();
    } else {
      initAdmin();
    }
  }
};

function languageSelect() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let target = event.target;
  event.stopPropagation();
  $('#jv-langList').slideToggle();
  $('#jv-langList li').off('click').on('click', function(e) {
    $('#jv-langList').slideUp();
    $(target).html($(this).text()).attr('class', 'languageSelect ' + $(this).attr('type'));
    loadlanguage($(this).attr('type'));
    changeLanguage($(this).attr('type'));
    localStorage.setItem('lang', $(this).attr('type'));
  })
}

$(document).click(function() {
  $('#jv-langList').slideUp();
});
$(document).ready(function() {
  let lang = url_lang || localStorage.getItem('lang');

  $('#jv-langOption').empty();
  let li = "";
  for (let i = 0; i < globalData.language.length; i++) {
    let langInfo = globalData.language[i];
    if (lang == langInfo.type) {
      $('#jv-languageSelect').html(langInfo.lang).attr('class', 'languageSelect ' + langInfo.type);
    }
    li += "<li type='" + langInfo.type + "'>" + langInfo.lang + "</li>";
  }
  $('#jv-langOption').append(li);
  loadlanguage(lang);
  changeLanguage(lang);

})
