// 初始化 CodeMirror 编辑器
var editor = null;

function subcomposefile() {
  var content = editor.getValue();
  if (content == '#请输入compose文本，或复制、拖拽到此处' ||
    !content ||
    content == '#Please enter the compose text, or copy or drag it here' ||
    content == '#請輸入compose文字，或複製、拖拽到此處') {
    return;
  }
  var file = $('#jv-composefileval').val();
  docker_container_create(content, 'yaml', true, false, file).then(function() {
    closewin($('#jv-composewin'));
  });
}

function getFileExtension(filename) {
  return filename.slice(filename.lastIndexOf('.') + 1);
}

(function() {


  $(document).ready(function() {
    $('.cancelBtn').click(function() {
      closewin($('#jv-composewin'));
    })

    let lang = url_lang || localStorage.getItem('lang');
    changeLanguage(lang);

    editor = CodeMirror.fromTextArea(document.getElementById("editor"), {
      mode: "yaml",
      lineNumbers: false
    });

    docker_compose_list($('#jv-compose-page'));

    // 获取编辑器容器元素
    var editorElement = editor.getWrapperElement();

    // 添加拖拽事件监听器
    editorElement.addEventListener("dragover", function(event) {
      event.preventDefault(); // 防止默认拖拽行为（如打开文件）
      editorElement.classList.add('drag-over'); // 添加视觉反馈
    });

    editorElement.addEventListener("dragleave", function(event) {
      editorElement.classList.remove('drag-over'); // 移除视觉反馈
    });

    editorElement.addEventListener("drop", function(event) {
      event.preventDefault();
      editorElement.classList.remove('drag-over'); // 移除视觉反馈

      // 获取拖拽的文件
      var file = event.dataTransfer.files[0];

      // 仅处理 YAML 文件 (可根据需要修改)
      if (file && file.type === "text/yaml" || file.name.endsWith('.yaml') || file.name.endsWith('.yml')) {
        var reader = new FileReader();
        // 读取文件内容，并在加载完成后插入到 CodeMirror 中
        reader.onload = function(e) {
          var content = e.target.result;
          editor.setValue(content); // 将文件内容插入编辑器
        };
        // 读取文件为文本
        reader.readAsText(file);
      } else {
        errorMessageBox("Please select a valid YAML file.", 'yamlfile');
      }
    });

    $('#jv-composefile').change(function(e) {
      var file = e.target.files[0];
      const reader = new FileReader();
      reader.onload = function(e) {
        const fileContent = e.target.result;
        editor.setValue(fileContent);
      };
      reader.readAsText(file);
    });

    $('#jv-composefileval').on('change', function() {
      var v = $(this).val();
      var t = getFileExtension(v);
      $('.jvc-btn').removeClass('disabledbtn');
      $('#jv-uploadbtn').removeClass('disabledbtn');
      if (t == 'yaml' || t == 'yml') {
        let data = {
          "token": getCookie('PHPSESSID') || "",
          "cmd": "docker_yml",
          "params": {
            "file": v
          }
        }

        $.ajax({
          url: '../../unas-docker/includes/index.php', //接口
          type: "post", //GET或POST
          data: JSON.stringify(data), //数据
          dataType: 'json',
          contentType: 'application/json',
          success: function(res) {
            var info = res.results || {};
            if (res.err == 0) {
              editor.setValue(info.content);
            }

          }, //回调成功方法
          error: function(xhr, textStatus) {
            console.log(xhr);
            console.log(textStatus);
          }
        });

      }

    });

  })

  //
})()
