var taht_ContainerDetails = null;
var containerInfo = {};
var containerDetailsInfo = {};
//容器详情
function refreshContainerDetails() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  containerInfo = JSON.parse($(t).data('info'));
  taht_ContainerDetails = showModel({
    title: containerInfo.Names.toString() + ' <span data-lang="containerDetails">容器详情</span>',
    oemplateName: 'jvt-containerDetails',
    id: 'jv-containerDetails',
    isShowApplicationBtn: false,
    isShowFooterBtn: false

  }, function(e) {

  })

  getContainerDetails(taht_ContainerDetails, containerInfo.Id);
  getNetworkName(taht_ContainerDetails);
}
//获取容器详情
function getContainerDetails(that, id) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/json',
    type: "get",
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        // console.log(result);
        let name = result.Name;
        if (name[0] == '/') {
          name = result.Name.substr(1);
        }
        that.find('.deleteBtnList a').each(function(i, e) {
          $(e).attr('onclick', 'dockerContainerControl("' + result.Id + '")');
        })
        result.Config.Cmd = result.Config.Cmd || "";
        that.find('.jvc-checkedLog').attr('onclick', 'logDetails_Edit("' + result.Id + '")');
        that.find('.jvc-checkContainer').attr('onclick', 'checkContainer_Edit("' + result.Id + '")');
        that.find('.jvc-statisticsModule').attr('onclick', 'statisticsInfo_Edit("' + result.Id + '")');
        that.find('.jvc-implementConsoleDesk').attr('onclick', 'implementConsoleDesk()').data('dataInfo', result);
        that.find('.editBtn').data('dataInfo', JSON.stringify(containerInfo));
        containerDetailsInfo = result;
        that.find('#jv-containerId').text(result.Id).attr('title', result.Id);
        that.find('#jv-editContainerName').val(name);
        that.find('#jv-RQIPAddress').text(result.NetworkSettings.IPAddress || '--');
        that.find('#jv-RQStatus').text(result.State.Status);
        that.find('#jv-RQCreated').text(result.Created);
        let startedAt = result.State.StartedAt;
        if (startedAt == '0001-01-01T00:00:00Z' || !startedAt) {
          startedAt = "--";
        }
        result.Config.Env = result.Config.Env || '';
        that.find('#jv-RQStartedAt').text(startedAt);
        that.find('#jv-RQImage').text(result.Image).attr('title', result.Image);
        that.find('#jv-RQCmd').text(result.Config.Cmd.toString()).attr('title', result.Config.Cmd.toString());
        that.find('#jv-RQEnv').text(result.Config.Env.toString()).attr('title', result.Config.Env.toString());
        that.find('#jv-RQEntrypoint').text(result.Config.Entrypoint || '--');
        let labelsStr = [];
        for (var variable in result.Config.Labels) {
          if (result.Config.Labels.hasOwnProperty(variable)) {
            labelsStr.push(variable + result.Config.Labels[variable]);
          }
        }
        that.find('#jv-RQLabels').text(labelsStr.toString() || '--').attr('title', labelsStr.toString());

        var portBindings = result.HostConfig.PortBindings;
        var ports = [];
        for (var variable in portBindings) {
          if (portBindings.hasOwnProperty(variable)) {
            let s = '';
            for (var i = 0; i < portBindings[variable].length; i++) {
              let portBindingsInfo = portBindings[variable][i];
              var portBindingsStr = '';
              if (portBindingsInfo.HostIp) {
                // portBindingsInfo.HostIp
                portBindingsStr += portBindingsInfo.HostIp + '-' + portBindingsInfo.HostPort + ' ';
                if (portBindingsInfo.HostIp.indexOf(':') != -1) {
                  portBindingsStr += '[' + portBindingsInfo.HostIp + ']' + '-' + portBindingsInfo.HostPort + ' ';
                }

              } else {
                portBindingsStr += '0.0.0.0:' + portBindingsInfo.HostPort + ' ';
              }
              s = portBindingsInfo.HostPort + '-' + variable;
              ports.push(portBindingsStr + '[::]:' + s);
            }
          }

        }
        that.find('#jv-RQPortBindings').text(ports.toString() || '--').attr('title', ports.toString());
        that.find('#jv-networksHost').empty();
        for (var variable in result.NetworkSettings.Networks) {
          if (result.NetworkSettings.Networks.hasOwnProperty(variable)) {
            var networksDom = wfTemplateAppend(that.find('#jv-networksHost'), 'jvt-networksItem', 'jvt-networksItem' + variable);
            networksDom.find('.networksName').text(variable);
            networksDom.find('.networksIPAddress').text(result.NetworkSettings.Networks[variable].IPAddress);
            networksDom.find('.networksGateway').text(result.NetworkSettings.Networks[variable].Gateway);
            networksDom.find('.networksMacAddress').text(result.NetworkSettings.Networks[variable].MacAddress);
            networksDom.find('.leaveNetwork').data('info', {
              id: result.Id,
              taht: that,
              name: variable
            })
          }
        }

        that.find('#jv-joinNetwork').data('info', {
          containerId: result.Id,
          taht: that
        })
        that.find('#jv-joinNetwork').data('info', {
          containerId: result.Id,
          taht: that
        })

        //
        that.find('#jv-cqcl option').each(function(i, e) {
          if ($(e).val() == result.HostConfig.RestartPolicy.Name) {
            $(e).attr('selected', 'selected');
            that.find('#jv-cqcl').attr('data-value', $(e).val());
          }
        })
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

//update重启策略
function updataRestartPolicy() {

  let name = taht_ContainerDetails.find('#jv-cqcl').attr('data-value');
  if (!name) {
    name = 'no';
  }
  let data = {
    RestartPolicy: {
      Name: name
    }
  }

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + containerInfo.Id + '/update',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(result) {},
    complete: function(xhr, textStatus) {},
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}
//离开网络
function leaveNetwork() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let info = $(t).data('info');

  let data = {
    Container: info.id,
    Force: false
  }
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/networks/' + info.name + '/disconnect',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(result) {},
    complete: function(xhr, textStatus) {
      if (xhr.status == 200) {
        getContainerDetails(info.taht, info.id);
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

//加入网络
function joinNetwork() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let info = $(t).data('info');

  let networksId = info.taht.find('#jv-networList').attr('data-value');

  let data = {
    Container: info.containerId
  }
  if (!networksId) {
    errorMessageBox('请选择网络');
    return;
  }

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/networks/' + networksId + '/connect',
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(result) {},
    complete: function(xhr, textStatus) {
      if (xhr.status == 200) {
        getContainerDetails(info.taht, info.containerId);
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}

// 获取网络列表
function getNetworkName(that) {

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/networks',
    type: "get"
  }

  postData(obj, {
    success: function(result) {
      if (result) {
        let dom = '';
        for (let i = 0; i < result.length; i++) {
          let info = result[i];
          dom += '<option value=' + info.Id + '>' + info.Name + '</option>';
        }
        that.find('#jv-networList').append(dom);

        var xx = that.find('#jv-networList option').sort(function(a, b) { //进行排序
          var aText = $(a).text();
          var bText = $(b).text();
          if (aText > bText) return 1;
          if (aText < bText) return -1;
          return 0;
        });
        that.find('#jv-networList').empty(); //清空
        that.find('#jv-networList').append(xx); //赋值
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

//编辑容器名称
function editContainerName() {
  $('#jv-popup').find('#jv-isedit').hide();
  $('#jv-popup').find('#jv-editZt').show();
  $('#jv-popup').find('#jv-editContainerName').attr('readonly', false).removeClass('readonly');
}
//确定编辑容器名称
function editContainerNameOk() {
  $('#jv-popup').find('#jv-isedit').show();
  $('#jv-popup').find('#jv-editZt').hide();
  $('#jv-popup').find('#jv-editContainerName').attr('readonly', true).addClass('readonly');
  let name = taht_ContainerDetails.find('#jv-editContainerName').val();
  if (!name) {
    errorMessageBox('容器名称不能为空！');
    return;
  }
  let data = {

  }

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + containerInfo.Id + '/rename?name=' + name,
    data: JSON.stringify(data)
  }
  postData(obj, {
    success: function(result) {},
    complete: function(xhr, textStatus) {
      if (xhr.status == 200 || xhr.status == 204) {
        getData();
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}
// 取消编辑容器名称
function cancelEditContainerName() {
  $('#jv-popup').find('#jv-isedit').show();
  $('#jv-popup').find('#jv-editZt').hide();
  $('#jv-popup').find('#jv-editContainerName').attr('readonly', true).addClass('readonly');
}


//从容器建立镜像
function containerEstablishImage() {
  let that_image = showSecondModel({
    title: '<span data-lang="createContainerIage">从容器建立镜像</span>',
    oemplateName: 'jvt-containerEstablishImage',
    id: 'jv-containerEstablishImage',
    isShowApplicationBtn: false,
    isShowFooterBtn: true,

  }, function(e) {
    if (e) {
      pullImage(that_image);
    }
  },'popupbox-y')

  that_image.find('.topNavBtnList .navBtnItem').click(function(e) {
    $(this).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
    registriesType = $(this).attr('data-type');
    if (registriesType == 'senior') {
      that_image.find('.jvc-registriesinputItem').slideUp();
    } else {
      that_image.find('.jvc-registriesinputItem').slideDown();
    }
  })

  getRegistries(that_image);
}

function pullImage(that) {

  let fromImage = that.find("input[name='registriesName']").val().toLowerCase();
  let data = {
    fromImage: ''
  }
  if (!fromImage) {
    errorMessageBox('请题写镜像名称');
    return;
  }

  if (registriesType == 'simple') {
    if (imageNameInfo != null) {
      fromImage = imageNameInfo.URL + '/' + fromImage
    }
    if (fromImage.indexOf(':') == -1) {
      fromImage = fromImage + ':latest';

    }
  }

  if (registriesType == 'senior') {
    fromImage = that.find("input[name='registriesName']").val();
  }
  data.fromImage = fromImage;

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/create?fromImage=' + fromImage,
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      if (result) {

      }
    },
    complete: function() {},
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}


// 查看日志
function logDetails_Edit(id) {
  that_log = showSecondModel({
    title: '日志详情',
    oemplateName: 'jvt-logDetails',
    id: 'jv-logDetails',
    isShowApplicationBtn: false,
    isShowFooterBtn: false
  }, function(e) {

  })

  if (that_log.find('#jv-isShowTimestamps').hasClass('open')) {
    logPsotData.timestamps = 1;
  } else {
    logPsotData.timestamps = 0;
  }

  getLog(id, logPsotData);
  window.containersLognIterval = setInterval(function() {
    getLog(id, logPsotData);
  }, 3000);
}


//检查
function checkContainer_Edit(id) {

  let that = showSecondModel({
    title: '检查',
    oemplateName: 'jvt-checkContainer',
    id: 'jv-checkContainer',
    isShowApplicationBtn: false,
    isShowFooterBtn: false

  }, function(e) {

  })
  let strText = {};

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/json',
    type: 'get'
  }
  postData(obj, {
    success: function(result) {

    },
    complete: function(event, xhr, options) {
      // console.log(event);
      if (event.status == 200) {
        strText = event.responseText;
        that.find('#jv-logDetailsContentList .text').jsonViewer(JSON.parse(event.responseText), '');

      }
    },
    error: function(xhr, textStatus) {

    }
  });

  that.find('.topNavBtnList .navBtnItem').click(function(e) {
    $(this).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
    if ($(this).attr('data-type') == 'tree') {
      let t = JSON.parse(strText);
      that.find('#jv-logDetailsContentList .text').jsonViewer(t, '');
    } else {
      that.find('#jv-logDetailsContentList .text').html(prettyFormat(strText));
    }

  })

}

//统计
function statisticsInfo_Edit(id) {
  that_statistics = showSecondModel({
    title: '统计',
    oemplateName: 'jvt-statisticsInfo',
    id: 'jv-statisticsInfo',
    isShowApplicationBtn: false,
    isShowFooterBtn: false

  }, function(e) {
  })

  initData.containsId = id;

  let langType = localStorage.getItem('lang')
  let cpuLang = 'CPU使用';
  let memoryLang = '内存';
  let cacheLang = '缓存';
  let networkLang = '网络'
  if (langType == 'en') {
    cpuLang = 'CPU usage';
    memoryLang = 'memory';
    cacheLang = 'cache';
    networkLang = 'network';
  }
  if (langType == 'tc') {
    memoryLang = '記憶體';
    cacheLang = '緩存';
    networkLang = '網絡';
  }


  cpuObj = {
    el: that_statistics.find('#jv-cpu')[0],
    legendData: [cpuLang],
    xAxisdata: [],
    titleText: 'CPU',
    formatterValue: '{value}%',
    py: '30%',
    seriesData: [{
      name: cpuLang,
      data: [],
      type: 'line',
      color: ['#56A3F2'],
    }]
  }

  memoryusageObj = {
    el: that_statistics.find('#jv-memoryusage')[0],
    legendData: [memoryLang, cacheLang],
    xAxisdata: [],
    titleText: memoryLang,
    formatterValue: function(data){
      return formSize(data);
    },
    py: '20%',
    seriesData: [{
        name: memoryLang,
        data: [], //this.cpudata,
        type: 'line',
        color: ['#3CD0B1'],
      },
      {
        name: cacheLang,
        data: [], //this.cpudata,
        type: 'line',
        color: ['#E6E264'],
      }
    ]
  }

  networkusageObj = {
    el: that_statistics.find('#jv-networkusage')[0],
    legendData: ['RX', 'TX'],
    xAxisdata: [],
    titleText: networkLang,
    formatterValue: function(data){
      return formSize(data);
    },
    py: '25%',
    seriesData: [{
        name: 'RX',
        data: [], //this.cpudata,
        type: 'line',
        color: ['#F2C66E'],
      },
      {
        name: 'TX',
        data: [], //this.cpudata,
        type: 'line',
        color: ['#FF7978'],
      }
    ]
  }
  getProcessesData(id);
  refreshEchartsData(id);
  statisticsIterval(id, initStatisticsData.refreshRate);
}
