function docker_exim_list(that, p, id) {
  that.find('#jv-subsidiaryDepartmentFile').empty();
  return new Promise(function(resolve, reject) {
    var target = '';
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_exim_list"
    }
    if (id != undefined) {
      data["params"] = {
        "filename": p,
        "type":"container"
      }
      target = '.jv-' + id;
      that.find(target).empty();
    } else {
      target = '#jv-' + 'subsidiaryDepartmentFile';
      that.find(target).empty();
    }

    $.ajax({
      url: '../../unas-docker/includes/index.php', //接口
      type: "post", //GET或POST
      data: JSON.stringify(data), //数据
      dataType: 'json',
      success: function(result) {
        resolve(result);
        var res = result.results;
        let info = result.results.dir || [];

        if (res.type == 'json') {
          unas_json = res.json;
          info = [];
        }

        if (result.err == 0) {
          fileListType = [];
          if (result.results.file && result.results.file.length && dir_file) {
            fileListType = result.results.file;
            info = info.concat(result.results.file);
          }
          for (let i = 0; i < info.length; i++) {
            var s = info[i].replace(/[\ |\~|\`|\!|\@|\#|\$|\%|\^|\&|\*|\(|\)|\-|\_|\+|\=|\||\\|\[|\]|\{|\}|\;|\:|\"|\'|\,|\<|\.|\>|\/|\?]/g, "")  + new Date().getTime();

            let subsidiaryItem = '';
            if (id == undefined) {
              subsidiaryItem = wfTemplateAppend(target, 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i + 'dirfile');
            } else {
              subsidiaryItem = wfTemplateAppend(that.find(target), 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i + new Date().getTime());
            }
            subsidiaryItem.attr('onclick','getdirList(this);');
            subsidiaryItem.attr('data-id', s);
            subsidiaryItem.attr('data-p', info[i]);
            subsidiaryItem.attr('data-slide', 'up');
            subsidiaryItem.data({
              depId: info[i],
            });
            var index = info[i].lastIndexOf(".");
            var ext = info[i].substr(index+1);
            var tr = ['tar','tar.gz','tgz','unas_tgz'];
            var json_ext = ['json', 'yml', 'yaml'];
            if (tr.indexOf(ext) != -1){
              subsidiaryItem.find('.wz-icon').attr('src', './image/file_tar.png');
            }
            if (json_ext.indexOf(ext) != -1){
              subsidiaryItem.find('.wz-icon').attr('src', './image/file_json.png');
            }
            subsidiaryItem.find('.subsidiaryInput').text(info[i]).data({
              depId: info[i],
            });
            let pth = subsidiaryItem.find('.subsidiaryDepartment').parent().parent().attr('data-p');
            if (pth != undefined) {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', pth + '/' + info[i])
            } else {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', info[i]);
            }
            subsidiaryItem.find('.subsidiaryDepartment').attr('class', 'subsidiaryDepartment jv-' + s);

          }
        } else {

        }
      }, //回调成功方法
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })
}

function getExportContainerDir(that, p, id) {
  that.find('#jv-dirpos').empty();
  return new Promise(function(resolve, reject) {
    var target = '';
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_exim_list"
    }
    if (id != undefined) {
      data["params"] = {
        "filename": p,
        "type":"container"
      }
      target = '.jv-' + id;
      that.find(target).empty();
    } else {
      target = '#jv-' + 'dirpos';
      that.find(target).empty();
    }

    $.ajax({
      url: '../../unas-docker/includes/index.php', //接口
      type: "post", //GET或POST
      data: JSON.stringify(data), //数据
      dataType: 'json',
      success: function(result) {
        resolve(result);
        let info = result.results.dir;

        if (result.err == 0) {
          for (let i = 0; i < info.length; i++) {
            var s = info[i].replace(/[\ |\~|\`|\!|\@|\#|\$|\%|\^|\&|\*|\(|\)|\-|\_|\+|\=|\||\\|\[|\]|\{|\}|\;|\:|\"|\'|\,|\<|\.|\>|\/|\?]/g, "") + new Date().getTime();

            let subsidiaryItem = '';
            if (id == undefined) {
              subsidiaryItem = wfTemplateAppend(target, 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i + 'dirpos');
            } else {
              subsidiaryItem = wfTemplateAppend(that.find(target), 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i + new Date().getTime());
            }
            subsidiaryItem.attr('onclick','getdirList(this);');
            subsidiaryItem.attr('data-id', s);
            subsidiaryItem.attr('data-p', info[i]);
            subsidiaryItem.attr('data-slide', 'up');
            subsidiaryItem.data({
              depId: info[i],
            });

            subsidiaryItem.find('.subsidiaryInput').text(info[i]).data({
              depId: info[i],
            });
            let pth = subsidiaryItem.find('.subsidiaryDepartment').parent().parent().attr('data-p');
            if (pth != undefined) {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', pth + '/' + info[i])
            } else {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', info[i]);
            }
            subsidiaryItem.find('.subsidiaryDepartment').attr('class', 'subsidiaryDepartment jv-' + s);

          }
        } else {

        }
      }, //回调成功方法
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })
}

function docker_compose_list(that, p, id) {
  that.find('#jv-composeFile').empty();
  return new Promise(function(resolve, reject) {
    var target = '';
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_exim_list"
    }
    if (id != undefined) {
      data["params"] = {
        "filename": p,
        "type": "container"
      }
      target = '.jv-' + id;
      that.find(target).empty();
    } else {
      target = '#jv-' + 'composeFile';
      that.find(target).empty();
    }

    $.ajax({
      url: '../../unas-docker/includes/index.php', //接口
      type: "post", //GET或POST
      data: JSON.stringify(data), //数据
      dataType: 'json',
      success: function(result) {
        resolve(result);
        var res = result.results;
        let info = result.results.dir || [];

        if (res.type == 'json') {
          unas_json = res.json;
          info = [];
        }

        if (result.err == 0) {
          fileListType = [];
          if (result.results.file && result.results.file.length && dir_file) {
            fileListType = result.results.file;
            info = info.concat(result.results.file);
          }
          for (let i = 0; i < info.length; i++) {
            var s = info[i].replace(/[\ |\~|\`|\!|\@|\#|\$|\%|\^|\&|\*|\(|\)|\-|\_|\+|\=|\||\\|\[|\]|\{|\}|\;|\:|\"|\'|\,|\<|\.|\>|\/|\?]/g, "") + new Date().getTime();

            let subsidiaryItem = '';
            if (id == undefined) {
              subsidiaryItem = wfTemplateAppend(target, 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i + 'dirfile');
            } else {
              subsidiaryItem = wfTemplateAppend(that.find(target), 'jvt-subsidiaryItem', 'jvt-subsidiaryItem-' + s + i + new Date().getTime());
            }
            subsidiaryItem.attr('onclick', 'getdirList(this);');
            subsidiaryItem.attr('data-id', s);
            subsidiaryItem.attr('data-p', info[i]);
            subsidiaryItem.attr('data-slide', 'up');
            subsidiaryItem.data({
              depId: info[i],
            });
            var index = info[i].lastIndexOf(".");
            var ext = info[i].substr(index + 1);
            var tr = ['tar', 'tar.gz', 'tgz', 'unas_tgz'];
            var json_ext = ['json', 'yml', 'yaml'];
            if (tr.indexOf(ext) != -1) {
              subsidiaryItem.find('.wz-icon').attr('src', './image/file_tar.png');
            }
            if (json_ext.indexOf(ext) != -1) {
              subsidiaryItem.find('.wz-icon').attr('src', './image/file_json.png');
            }
            subsidiaryItem.find('.subsidiaryInput').text(info[i]).data({
              depId: info[i],
            });
            let pth = subsidiaryItem.find('.subsidiaryDepartment').parent().parent().attr('data-p');
            if (pth != undefined) {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', pth + '/' + info[i])
            } else {
              subsidiaryItem.find('.subsidiaryDepartment').attr('data-p', info[i]);
            }
            subsidiaryItem.find('.subsidiaryDepartment').attr('class', 'subsidiaryDepartment jv-' + s);

          }
        } else {

        }
      }, //回调成功方法
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })
}

function getdirList(t) {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  let p = $(t).attr('data-p');
  if ($(t).attr('data-slide') == 'up') {
    $(t).attr('data-slide', 'down');
    $(t).find('.subsidiaryDepartment').slideDown();
    if ($(t).parent().attr('data-p') != undefined) {
      p = $(t).parent().attr('data-p') + '/' + $(t).attr('data-p');
    }
    switch (dir_file) {
      case 'import':
        docker_exim_list($(t), p, $(t).attr('data-id'));
        break;
      case 'export':
        getExportContainerDir($(t), p, $(t).attr('data-id'));
        break;
      case 'compose':
        docker_compose_list($(t), p, $(t).attr('data-id'));
        break;
      default:

    }

  } else {
    $(t).attr('data-slide', 'up');
    $(t).find('.subsidiaryDepartment').slideUp();
    if ($(t).parent().attr('data-p') != undefined) {
      p = $(t).parent().attr('data-p') + '/' + $(t).attr('data-p');
    }
  }
  $(targetInput).val(p).attr('title', p).trigger('change');
}
