var that_statistics = null;
var initStatisticsData = {
  refreshRate: 5
}
var cpuObj = {};
var memoryusageObj = {};
var networkusageObj = {};
//统计
function statisticsInfo(id) {
  that_statistics = showModel({
    title: '<span data-lang="containerStatistics">统计</span>',
    oemplateName: 'jvt-statisticsInfo',
    id: 'jv-statisticsInfo',
    isShowApplicationBtn: false,
    isShowFooterBtn: false

  }, function(e) {
  })
  let langType = localStorage.getItem('lang')
  let cpuLang = 'CPU使用';
  let memoryLang = '内存';
  let cacheLang = '缓存';
  let networkLang = '网络'
  if (langType == 'en') {
    cpuLang = 'CPU usage';
    memoryLang = 'memory';
    cacheLang = 'cache';
    networkLang = 'network';
  }
  if (langType == 'tc') {
    memoryLang = '記憶體';
    cacheLang = '緩存';
    networkLang = '網絡';
  }

  initData.containsId = id;
  cpuObj = {
    el: $('#jv-popup').find('#jv-cpu')[0],
    legendData: [cpuLang],
    xAxisdata: [],
    titleText: 'CPU',
    formatterValue: '{value}%',
    py: '30%',
    seriesData: [{
      name: cpuLang,
      data: [],
      type: 'line',
      color: ['#56A3F2'],
    }]
  }

  memoryusageObj = {
    el: $('#jv-popup').find('#jv-memoryusage')[0],
    legendData: [memoryLang, cacheLang],
    xAxisdata: [],
    titleText: memoryLang,
    formatterValue: function(data){
      return formSize(data);
    },
    py: '20%',
    seriesData: [{
        name: memoryLang,
        data: [], //this.cpudata,
        type: 'line',
        color: ['#3CD0B1'],
      },
      {
        name: cacheLang,
        data: [], //this.cpudata,
        type: 'line',
        color: ['#E6E264'],
      }
    ]
  }

  networkusageObj = {
    el: $('#jv-popup').find('#jv-networkusage')[0],
    legendData: ['RX', 'TX'],
    xAxisdata: [],
    titleText: networkLang,
    formatterValue: function(data){
      return formSize(data);
    },
    py: '25%',
    seriesData: [{
        name: 'RX',
        data: [], //this.cpudata,
        type: 'line',
        color: ['#F2C66E'],
      },
      {
        name: 'TX',
        data: [], //this.cpudata,
        type: 'line',
        color: ['#FF7978'],
      }
    ]
  }
  getProcessesData(id);
  refreshEchartsData(id);
  statisticsIterval(id, initStatisticsData.refreshRate);
}

function statisticsIterval(id, time) {
  window.containersStatisticsIterval = setInterval(function() {
    getProcessesData(id);
    refreshEchartsData(id);
  }, time * 1000);
}

//获取图像数据
function refreshEchartsData(id) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/stats?stream=false',
    type: 'get'
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        var date = new Date();
        var timeData = '';
        var hh = (date.getHours() < 10 ? '0' + date.getHours() : date.getHours()) + ':';
        var mm = (date.getMinutes() < 10 ? '0' + date.getMinutes() : date.getMinutes()) + ':';
        var ss = (date.getSeconds() < 10 ? '0' + date.getSeconds() : date.getSeconds());
        timeData = hh + mm + ss;

        var cpuData = (result.cpu_stats.cpu_usage.total_usage - result.precpu_stats.cpu_usage.total_usage) / (result.cpu_stats.system_cpu_usage - result.precpu_stats.system_cpu_usage) * result.cpu_stats.online_cpus * 100;
        cpuObj.xAxisdata.push(timeData);
        cpuObj.seriesData[0].data.push(cpuData.toFixed(2));
        var memory = 0,
          cache = 0;
        if ($.isEmptyObject(result.memory_stats) != true) {
          cache = result.memory_stats.stats.cache || 0;
          memory = result.memory_stats.usage - cache;
        }

        memoryusageObj.xAxisdata.push(timeData);

        memoryusageObj.seriesData[0].data.push(memory);
        memoryusageObj.seriesData[1].data.push(cache);

        networkusageObj.xAxisdata.push(timeData);

        let rx_bytes = 0;
        let tx_bytes = 0;
        for (var variable in result) {
          if (result.hasOwnProperty(variable)) {
            if (variable == 'networks') {
              let networksInfo = result[variable]
              for (var networksValue in networksInfo) {
                if (networksInfo.hasOwnProperty(networksValue)) {
                  rx_bytes += networksInfo[networksValue].rx_bytes;
                  tx_bytes += networksInfo[networksValue].tx_bytes;
                }
              }
            }
          }
        }
        networkusageObj.seriesData[0].data.push(rx_bytes);
        networkusageObj.seriesData[1].data.push(tx_bytes);


        setEchartsData(cpuObj);
        setEchartsData(memoryusageObj);
        setEchartsData(networkusageObj);
      }
    },
    complete: function(event, xhr, options) {

    },
    error: function(xhr, textStatus) {

    }
  }, false);

}

//获取Processes列表
function getProcessesData(id) {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/top',
    type: 'get'
  }
  postData(obj, {
    success: function(result) {
      that_statistics.find('#jv-statisticsTitles').empty();
      that_statistics.find('#jv-statisticsProcessesHost').empty();
      let titles = '';
      if (result) {
        for (let i = 0; i < result.Titles.length; i++) {
          let info = result.Titles[i];
          titles += '<div class="" style="width:12.5%;">' + result.Titles[i] + '</div>';
        }
        for (let i = 0; i < result.Processes.length; i++) {
          let info = result.Processes[i];
          let processes = '';
          var processesDom = wfTemplateAppend(that_statistics.find('#jv-statisticsProcessesHost'), 'jvt-statisticsProcessesItem', 'jvt-statisticsProcessesItem' + i);

          for (var j = 0; j < info.length; j++) {
            var h = '<div style="width:33.33%">'+
            '<div  class="fn-tr-label">' + result.Titles[j] + '</div>' +
            '<div class="ellipsis" style="">' + info[j] + '</div>' +
            '</div>';

            processes += h
          }
          processesDom.html(processes);
        }
        that_statistics.find('#jv-statisticsTitles').html(titles);
      }
    },
    complete: function(event, xhr, options) {

    },
    error: function(xhr, textStatus) {

    }
  }, false);
}


//设置图形数据
function setEchartsData(obj) {

  // 基于准备好的dom，初始化echarts实例
  var myChart = echarts.init(obj.el);
  let option = {
    tooltip: {
      trigger: 'axis'
    },
    legend: {
      data: obj.legendData, //['CPU使用'],
      bottom: 8,
      left: obj.py,
      textStyle: {
        color: '#333'
      }
    },
    title: {
      text: obj.titleText, //'Container_CPUusage',
      textStyle: {
        //文字颜色
        color: '#1E88D9',
        //字体粗细 'normal','bold','bolder','lighter',100 | 200 | 300 | 400...
        fontWeight: '400',
        //字体大小
        fontSize: 12,
        marginTop: 10
      }
    },
    grid: {
      left: '3%',
      top: '18%',
      right: '4%',
      bottom: '20%',
      containLabel: true
    },
    xAxis: {
      type: 'category',
      boundaryGap: false,
      data: obj.xAxisdata,
      axisLabel: {
        show: true,
        textStyle: {
          color: '#333', //更改坐标轴文字颜色
          fontSize: 10 //更改坐标轴文字大小
        }
      },
      axisTick: { //轴刻度线
        "show": false
      },
      splitLine: {
        "show": false
      },
      axisLine: {
        show: true,
        lineStyle: {
          type: 'solid',
          color: '#ddd',
          width: '1'
        }
      },

    },

    yAxis: {
      axisLine: {
        show: true,
        lineStyle: {
          type: 'solid',
          color: '#ddd',
          width: '1'
        }
      },
      type: 'value',
      axisLabel: {
        formatter: obj.formatterValue,
        textStyle: {
          color: '#333'
        }
      },
      splitLine: {
        "show": false
      }
    },
    series: obj.seriesData
  }

  myChart.setOption(option)
}

function selectTiem() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  clearInterval(window.containersStatisticsIterval);
  statisticsIterval(initData.containsId, v);
}

(function() {
  'use strict'


}())
