//搜索镜像
function searchImage() {
  that.find('#jv-imageListHost').empty();
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let q = that.find('#jv-searchVal').val();
  let page = 1;
  let page_size = 30;

  if (!q) {
    return;
  }

  that.find('.goback').show();
  $(t).addClass('selectnavBtnItem');
  that.find('.topNavBtnList .navBtnItem').removeClass('selectnavBtnItem');

  that.find('#jv-registriesImageItem').hide();
  that.find('#jv-searchImageItem').show();
  that.find('#jv-imgageLoading').show();
  $('#jv-box-footer').hide();
  that.find('#jv-nullimages').hide();
  $.ajax({
    url: '../hub/v2/search/repositories/?query=' + q + '&page=' + page + '&page_size=' + page_size,
    type: "get",
    dataType: 'json',
    contentType: "application/json;charset=utf-8",
    headers: {
      'Search-Version': 'v3'
    },
    success: function(result) {
      that.find('#jv-imgageLoading').hide();
      let info = result;
      info.results = info.results || [];
      info.results = info.results.sort(function(a, b){
          if(a.star_count > b.star_count) return -1;
          else  return 1;
      })
      for (var i = 0; i < info.results.length; i++) {
        const tep = info.results[i];
        var imageListHostDom = wfTemplateAppend(that.find('#jv-imageListHost'), 'jvt-searchImageItem', 'jvt-searchImageItem' + i);
        imageListHostDom.find('.name').html(tep.repo_name).attr('title', tep.repo_name);
        imageListHostDom.find('.stars').html(tep.star_count);
        imageListHostDom.find('.icon_down').data('downinfo', tep);
        imageListHostDom.find('.imag_linkicon').data('data-imageName', tep.repo_name);
        imageListHostDom.find('.imglistSelectControl').attr('name', tep.repo_name);
      }
    },
    complete: function(xhr) {

    },
    error: function(xhr, textStatus) {

    }
  })

}



//下载镜像
function downImage() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let info = $(t).data('downinfo');
  let tagV = $(t).parent().parent().find('.imglistSelectControl').html();
  let name = info.repo_name + ':' + tagV;

  imagePull(name);

}
//取消镜像下载
function cancelPull() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let info = $(t).data('dataInfo');

  imagePull(info.image, 'stop');
}


// 选择tag
function imglistSelectControl() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  $(t).siblings('.bbcon').slideToggle(function(e) {
    if (!$(this).is(':hidden') && !$(t).siblings('.bbcon').find('.bbList').children().length) {
      $(t).siblings('.bbcon').find('.bbList').html('');
      $(t).siblings('.bbcon').find('.vListloading').show();
      let data = {
        "token": getCookie('PHPSESSID') || "",
        "cmd": "docker_get_tags",
        "params": {
          "repository": $(t).attr('name')
        }
      }
      jQuery.ajax({
        url: '../../unas-docker/includes/index.php',
        type: "post",
        dataType: 'json',
        contentType: "application/json;charset=utf-8",
        data: JSON.stringify(data),
        success: function(result) {
          $(t).siblings('.bbcon').find('.vListloading').hide();
          if (result.err == 0) {
            let h = '<li>latest</li>'
            for (var i = 0; i < result.results.tags.length; i++) {
              if (result.results.tags[i] != 'latest') {
                h += "<li>" + result.results.tags[i] + "</li>"
              }
            }
            $(t).siblings('.bbcon').find('.bbList').append(h);
          }

        },
        complete: function(xhr) {

        },
        error: function(xhr) {

        }
      })

    }
  });

  $(t).parent().parent().parent().siblings().find('.bbcon').slideUp();
  $(t).siblings('.bbcon').find('.bbList').on('click', 'li', function() {
    $(t).html($(this).html());
    $(t).siblings('.bbcon').slideUp();
  })
}

//单个删除
function actionsDelete() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let info = $(t).data('dataInfo');
  let isForce = false;
  initData.deleteName = [];
  initData.checkCount = 0;
  initData.deleteName.push(info.Id);
  initData.checkCount = initData.deleteName.length;

  if ($(t).attr('data-type') == 'force') {
    isForce = true;
  }
  deleteImageItem(isForce);
}

//创建容器
function createImageContainer() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let info = $(t).data('dataInfo');
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/images/' + info.Id + '/json',
    type: 'get'
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        globalData.isImage = false;
        is_create = 0;
        createContainer();
        that_createContainer.find('#jv-myTag').val(info.RepoTags[0]);
        $('#jv-subsidiaryDepartment').empty();
        getCrporateCorporat(that_createContainer).then(function() {
          basicContainerData(that_createContainer, result);
        });
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}
//默认容器常规设置数据
function basicContainerData(that, result) {
  // 设置手动网络端口
  let config = result.Config || {};
  var p_index = 0;
  for (let variable in config.ExposedPorts) {
    if (config.ExposedPorts.hasOwnProperty(variable)) {
      let key = variable.split('/');
      let sdwldkHost = wfTemplateAppend(that.find('#jv-sdwldkHost'), 'jvt-sdwldk', 'jvt-sdwldk' + key[0] + p_index);
      sdwldkHost.find("input[name='host']").val(key[0]);
      sdwldkHost.find("input[name='contalner']").val(key[0]);

      sdwldkHost.find('.selectControlTcpUdp option').each(function(i, e) {
        if ($(e).val() == key[1]) {
          $(e).attr('selected', 'selected');
        }
      })
    }
    p_index++;
  }
  //初始化命令和日志记录数据
  basicContainerCommandLoging(that, result);
  // 初始化数据卷
  var volumes_index = 0;
  for (var variable in config.Volumes) {
    if (config.Volumes.hasOwnProperty(variable)) {
      let mountsDom = wfTemplateAppend(that.find('#jv-volumeDataHost'), 'jvt-volumeDataItem', 'jvt-volumeDataItem' + volumes_index);
      mountsDom.find("input[name='containervalue']").val(variable);
      volumes_index ++;
    }
  }

  //初始化环境变量
  let envs = result.Config.Env || [];
  for (var i = 0; i < envs.length; i++) {
    let envData = envs[i].split('=');
    let envDom = wfTemplateAppend(that.find('#jv-environmentVariablesHost'), 'jvt-environmentVariablesItem', 'jvt-environmentVariablesItem' + i);
    envDom.find("input[name='fooval']").val(envData[0]);
    envDom.find("input[name='barval']").val(envData[1]);
  }
  //初始化标签
  let labels = result.Config.Labels || {};
  let labels_i = 0;
  for (var variable in labels) {
    if (labels.hasOwnProperty(variable)) {
      let labelsDom = wfTemplateAppend(that.find('#jv-labelsHost'), 'jvt-labelsItem', 'jvt-labelsItem' + labels_i);
      labelsDom.find("input[name='fooval']").val(variable);
      labelsDom.find("input[name='barval']").val(labels[variable]);
    }
    labels_i++;
  }

}

//初始化命令和日志记录数据
function basicContainerCommandLoging(that, result) {

  let cmds = '',
    entrypoints = '';
  if (result.Config.Cmd) {
    if ((typeof result.Config.Cmd == 'object') && result.Config.Cmd.constructor == Array) {
      cmd_parts = [];
      result.Config.Cmd.forEach(element => {
        if (element.search(' ') != -1){
          cmd_parts.push('"' + element + '"');
        }else{
          cmd_parts.push(element);
        }
      });
      cmds = cmd_parts.join(' ');
    }
    if ((typeof result.Config.Cmd == 'string') && result.Config.Cmd.constructor == String) {
      cmds = result.Config.Cmd;
    }
  }

  if (result.Config.Entrypoint) {
    if ((typeof result.Config.Entrypoint == 'object') && result.Config.Entrypoint.constructor == Array) {
      entrypoint_parts = [];
      result.Config.Entrypoint.forEach(element => {
        if (element.search(' ') != -1){
          entrypoint_parts.push('"' + element + '"');
        }else{
          entrypoint_parts.push(element);
        }
      });
      entrypoints = entrypoint_parts.join(' ');
    }
    if ((typeof result.Config.Entrypoint == 'string') && result.Config.Entrypoint.constructor == String) {
      entrypoints = result.Config.Entrypoint;
    }
  }

  that.find("input[name='cmd']").val(cmds);
  that.find("input[name='entrypoint']").val(entrypoints);
  that.find("input[name='workingDir']").val(result.Config.WorkingDir);
  that.find("input[name='user']").val(result.Config.User);
  /*
  let consoleList = that.find('.jvc-consoleList').children();

  consoleList.each(function(i, e) {
    $(e).find('img').attr('src', './image/radio.png');
    if (result.Config.OpenStdin && result.Config.Tty) {
      $(e).find('img[data-type="-i-t"]').attr('src', './image/radio_selected.png');
    }

    if (result.Config.OpenStdin && !result.Config.Tty) {
      $(e).find('img[data-type="-i"]').attr('src', './image/radio_selected.png');

    }

    if (!result.Config.OpenStdin && result.Config.Tty) {
      $(e).find('img[data-type="-t"]').attr('src', './image/radio_selected.png');
    }

    if (!result.Config.OpenStdin && !result.Config.Tty) {
      $(e).find('img[data-type="none"]').attr('src', './image/radio_selected.png');
    }

  })
  */
}


// 正在拉取
function docker_pulling() {
  return new Promise(function(resolve, reject) {
    let t = null;
    let data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_pulling"
    };

    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }
    postData(obj, {
      success: function(result) {
        // console.log(result);
        if (result) {
          resolve(result);
          clearTimeout(docker_pullingOutTime);
          initData.pullingList = result.results;
          if (result.results.length) {
            clearInterval(pullingOutTime);
            initData.pullingList = result.results;
            for (var i = 0; i < result.results.length; i++) {
              var t = '';
              $('#jv-d-tbodybox').children().each(function(j, e) {
                if (result.results[i].image == $(e).find('.image_RepoTags').text()) {
                  for (var variable in result.results[i].progress) {
                    if (result.results[i].progress.hasOwnProperty(variable)) {
                      for (var index in result.results[i].progress[variable]) {
                        if (result.results[i].progress[variable].hasOwnProperty(index)) {
                          if (index == 'info') {
                            if (result.results[i].progress[variable].info) {
                              t += result.results[i].progress[variable].info + '\r ';
                            }
                          } else {
                            let p = '';
                            if (!Array.isArray(result.results[i].progress[variable].progressDetail)) {
                              if (result.results[i].progress[variable].progressDetail.current) {
                                p += (formSize(result.results[i].progress[variable].progressDetail.current) + '/' + formSize(result.results[i].progress[variable].progressDetail.total));
                              }
                            }

                            t += (variable + ": " + result.results[i].progress[variable].status + " " + p + '\r ')

                          }
                        }
                      }

                    }
                  }

                }
              });
              let str = Array.from(new Set(t.split('\r'))).join('\r');
              result.results[i].t = str;
            }

            if (globalData.hashName == '/image') {
              if (result.results.length) {
                upData(result.results);
                docker_pullingOutTime = setTimeout(function() {
                  docker_pulling();
                }, 3000);
              }

            }

          } else {
            upData();

          }

        }

      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    }, false);
  })
}

//跳转到image详情页
function linkImager() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let name = $(t).data('data-imageName');
  if (name.indexOf('/') == -1) {
    window.open('https://hub.docker.com/_/' + name, '_blank');
  }else {
    window.open('https://hub.docker.com/r/' + name, '_blank');
  }
}

function showFilterModle() {
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  $('#jv-filterList').slideToggle();
  $('#jv-filterList li').each(function(i, e) {
    e.onclick = function(ve) {
      ve.stopPropagation();
      var len = $('#jv-filterList li input[type=checkbox]').length;
      var sib = jQuery(ve.target).parent().siblings();
      if (!sib.find('input[type=checkbox]').prop('checked')) {
        ve.target.checked = true;
      }
      var len_c = $('#jv-filterList li input[type=checkbox]:checked').length;

      if (len_c == len) {
        localStorage.setItem('filtermodle', 'all');
      }else {
        var v = $('#jv-filterList li input[type=checkbox]:checked').attr('actived');
        localStorage.setItem('filtermodle', v);
      }

      upData();
    }

    if (filtermodle == 'all') {
      $('#jv-filterList li input[type=checkbox]').prop('checked', true);
    }else {
      var actived = jQuery(e).find('input[type=checkbox]').attr('actived');
      if (filtermodle == actived) {
        jQuery(e).find('input[type=checkbox]').prop('checked', true);
      }
    }

  })
  $(document).on('click', function(e) {
    e.stopPropagation();
    $('#jv-filterList').slideUp();
  })
}
