SPA_RESOLVE_INIT = function(transition) {
  // document.getElementById("content").innerHTML = '<p style="color:#099fde;">当前异步渲染首页'+ JSON.stringify(transition) +'</p>'
}
SPA_RESOLVE_HTML = function(transition) {}
// var ip_reg = /^([01]?\d\d?|2[0-4]\d|25[0-5])(?:\.[01]?\d\d?|\.2[0-4]\d|\.25[0-5]){3}\/[0-2]\d|\/3[0-2]$/;
var ip_reg = /\b(([2]([0-4][0-9]|[5][0-5])|[0-1]?[0-9]?[0-9])[.]){3}(([2]([0-4][0-9]|[5][0-5])|[0-1]?[0-9]?[0-9]))\b\/\b([0-9]|[12][0-9]|3[0-2])\b/g;

function ip2int(ip) {
  return ip.split('.').reduce(function(ipInt, octet) {
    return (ipInt << 8) + parseInt(octet, 10)
  }, 0) >>> 0;
}

function int2ip(ipInt) {
  return ((ipInt >>> 24) + '.' + (ipInt >> 16 & 255) + '.' + (ipInt >> 8 & 255) + '.' + (ipInt & 255));
}

function getiprange(ip, that) {
  if (!ip) {
    return;
  }

  if (!ip_reg.test(ip)) {
    that.find('#jv-IP-Range').hide();
    that.find('#jv-Invalidiprange').show();
  }else {
    that.find('#jv-Invalidiprange').hide();
    that.find('#jv-IP-Range').show();
  }
  ip_reg.lastIndex = 0;

  var ip_base = ip.split('/')[0];
  var ip_mask = ip.split('/')[1];

  var ip_int = ip2int(ip_base);
  var ip_umask = 32 - ip_mask;
  var ip_from = int2ip(ip_int >> ip_umask << ip_umask);
  var ip_to = int2ip((((ip_int >> ip_umask) + 1) << ip_umask) - 1);

  return ip_from + "-" + ip_to;
}

var initData = {
  list: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: 1000000, //每页数量
  checkCount: 0, //已选列表数量
  deleteName: [], //保存删除列表名称
}
var that = null;

// 添加网络
function addNetwork() {
  that = showModel({
    title: '<span data-lang="createNetwork">添加网络</span>',
    oemplateName: 'jvt-addNetworkTemplates',
    id: 'jv-addNetworkModalContent',
    isShowApplicationBtn: false,
    isShowFooterBtn: true

  }, function(e) {
    if (e) {
      createNetworks();
    }
  })

  that.find('#jv-ipv4 input[name="iprange"]').on('input propertychange', function() {
    if ($(this).val()) {
      that.find('#jv-IP-Range').text(getiprange($(this).val(), that));
    }else {
      that.find('#jv-IP-Range').text('');
    }
  })

  // that.find('#jv-ipv4 input[name="iprange"]').on('blur', function(e) {
  //   that.find('#jv-IP-Range').text(getiprange($(this).val(), that));
  // })

};

function createNetworks() {
  var data = {
    "Driver": that.find('.selectControl option:selected').val() == 'ovs' ? 'macvlan' : that.find('.selectControl option:selected').val(),
    "CheckDuplicate": true,
    "Internal": that.find('.jvc-Internal').attr('internal') == 'false' ? false : true, //隔离网络
    "Attachable": that.find('.jvc-Attachable').attr('attachable') == 'false' ? false : true, //启用手动容器连接
    "EnableIPv6": that.find('.jvc-EnableIPv6').attr('EnableIPv6') == 'false' ? false : true,
    "IPAM": {
      "Driver": "default",
      "Config": []
    },
    "Labels": {},
    "Name": that.find('#jv-neteorkName').val(),
    "Options": {}
  }
  let excludedIpv4List = that.find('#jv-excludedIpv4Host').children();
  let excludedIpv6List = that.find('#jv-excludedIpv6Host').children();
  let optionList = that.find('#jv-driverOptionHost').children();
  let labelList = that.find('#jv-addlabelHost').children();
  let v4_subnet = that.find("#jv-ipv4 input[name='subnet']").val();
  let v4_gateway = that.find("#jv-ipv4 input[name='gateway']").val();
  let v4_iprange = that.find("#jv-ipv4 input[name='iprange']").val();
  let v6_subnet = that.find("#jv-ipv6 input[name='subnet']").val();
  let v6_gateway = that.find("#jv-ipv6 input[name='gateway']").val();
  let v6_iprange = that.find("#jv-ipv6 input[name='iprange']").val();

  if (v4_iprange && !ip_reg.test(v4_iprange)) {
    errorMessageBox('IPV4网络配置 IP范围格式错误！');
    return;
  }
  ip_reg.lastIndex = 0;

  if (that.find('.selectControl option:selected').val() == 'ovs') {
    data.Options['parent'] = that.find('#jv-ovsOption').val();
    data.Labels['unasnetwork'] = 'ovs';
  }

  if (optionList.length) {
    optionList.each(function(i, e) {
      let key = $(e).find("input[name='key']").val();
      let val = $(e).find("input[name='value']").val();
      data.Options[key] = val;
    })
  }
  if (labelList.length) {
    labelList.each(function(i, e) {
      let key = $(e).find("input[name='key']").val();
      let val = $(e).find("input[name='value']").val();
      data.Labels[key] = val;
    })
  }

  let configList = {}
  if (v4_subnet) {
    configList['Subnet'] = v4_subnet;
  }
  if (v4_gateway) {
    configList['Gateway'] = v4_gateway;
  }
  if (v4_iprange) {
    configList['IPRange'] = v4_iprange;
  }
  let auxiliaryAddresses = {};
  if (v4_subnet || v4_gateway || v4_iprange) {
    if (excludedIpv4List.length) {
      excludedIpv4List.each(function(i, e) {
        let val = $(e).find("input[name='value']").val();
        let device = 'device' + i;
        auxiliaryAddresses[device] = val;
        configList['AuxiliaryAddresses'] = auxiliaryAddresses;
      })

    }
    data.IPAM.Config.push(configList);
  }

  if (!that.find('#jv-ipv6').is(":hidden")) {
    let v6_configList = {}
    if (v6_subnet) {
      v6_configList['Subnet'] = v6_subnet;
    }
    if (v6_gateway) {
      v6_configList['Gateway'] = v6_gateway;
    }
    if (v6_iprange) {
      v6_configList['IPRange'] = v6_iprange;
    }
    let v6_auxiliaryAddresses = {};
    if (v6_subnet || v6_gateway || v6_iprange) {
      if (excludedIpv6List.length) {
        excludedIpv6List.each(function(i, e) {
          let val = $(e).find("input[name='value']").val();
          let device = 'device' + i;
          v6_auxiliaryAddresses[device] = val;
          v6_configList['AuxiliaryAddresses'] = v6_auxiliaryAddresses;
        })

      }
      data.IPAM.Config.push(v6_configList);
    }
  }

  if (!that.find('#jv-neteorkName').val()) {
    errorMessageBox('请填写网络名称');
    return;
  }

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/networks/create',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      if (result) {
        closePopup();
        inNetworls();
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

//添加附加选项
function addDriverOption(target, template) {
  let len = that.find(target).children().length;
  var volumeDom = wfTemplateAppend(that.find(target), template, template + len);
}
//删除附加选项
function deleteDriverOption() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  $(t).parent().remove();
}
// 设置是否打开隔离网络
function setInternal(t) {
  if ($(t).hasClass('open')) {
    $(t).attr('internal', true);
  } else {
    $(t).attr('internal', false);
  }
}

// 设置是否打开隔离网络
function setipv6(t) {
  if ($(t).hasClass('open')) {
    $(t).attr('enableipv6', true);
  } else {
    $(t).attr('enableipv6', false);
  }
}

// 设置是否启用手动容器连接
function setAttachable(t) {
  if ($(t).hasClass('open')) {
    $(t).attr('attachable', true);
  } else {
    $(t).attr('attachable', false);
  }
}

//选择驱动程序
function selectControl() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  if (v == 'ipvlan' || v == 'overlay') {
    that.find('#jv-ipv6').hide();
  } else {
    that.find('#jv-ipv6').show();
  }
  if (v == 'ovs') {
    that.find('#jv-isOvs').show();
    inspectOvs();
  } else {
    that.find('#jv-isOvs').hide();
  }
}
//ovs选择
function selectOvsControl() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  inspectOvs();
}
//接口
function inNetworls() {

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/networks',
    type: "get"
  }

  postData(obj, {
    success: function(result) {
      if (result) {
        initData.list = result;
        initData.count = result.length;
        refreshInfo(result, initData.count, initData.curr);
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

//数据更新
function refreshInfo(data, count, curr) {
  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: initData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        initData.curr = obj.curr; //得到当前页，以便向服务端请求对应页的数据。
        $('#jv-gopage').text(obj.curr);
        $('#jv-pageitemV').text(initData.limit);
        let t = arrTrans(initData.limit, data);
        $('#jv-d-tbodybox').empty();
        if (data.length) {
          var len = t[initData.curr - 1].length;
          for (var i = 0; i < len; i++) {
            let info = t[initData.curr - 1][i];
            var networkDom = wfTemplateAppend('#jv-d-tbodybox', 'jvt-d-tr', 'jvt-d-tr' + i);
            networkDom.find('.jvc-checkbox').data('dataInfo', info);
            let title = '禁止修改内置网络';
            if (localStorage.getItem('lang') == 'en') {
              title = 'Forbid to edit internal networks';
            }
            if (localStorage.getItem('lang') == 'tc') {
              title = '禁止修改內寘網絡';
            }

            if (info.Name == 'host' || info.Name == 'none' || info.Name == 'bridge') {
              networkDom.find('.jvc-checkbox').attr('disabled', true).attr('title', title);
            }
            networkDom.find('.network_Name').text(info.Name);
            networkDom.find('.networ_Stack').text('-');
            networkDom.find('.network_Scope').text(info.Scope);
            if (jQuery.isEmptyObject(info.Labels)) {
              networkDom.find('.network_Drive').text(info.Driver).addClass(info.Driver);
            }else {
              for (var v in info.Labels) {
                if (info.Labels.hasOwnProperty(v)) {
                  if (v == 'unasnetwork') {
                    networkDom.find('.network_Drive').text(info.Labels[v]).addClass(info.Labels[v]);
                  }
                }
              }
            }

            networkDom.find('.network_Attachable').text(info.Attachable);
            networkDom.find('.network_Internale').text(info.Internal);
            if (info.IPAM) {
              networkDom.find('.network_IPAM').text(info.IPAM.Driver);
              if (info.IPAM.Config && info.IPAM.Config.length) {
                let gateway = '',
                  subnet = '';
                for (var j = 0; j < info.IPAM.Config.length; j++) {
                  if (info.IPAM.Config[j].Gateway) {
                    gateway += info.IPAM.Config[j].Gateway + ',';
                  }
                  if (info.IPAM.Config[j].Subnet) {
                    subnet += info.IPAM.Config[j].Subnet + ',';
                  }

                }
                if (gateway.substring(0, gateway.length - 1)) {
                  networkDom.find('.network_Gateway').text(gateway.substring(0, gateway.length - 1));
                  networkDom.find('.network_Gateway').attr('title', gateway.substring(0, gateway.length - 1));
                } else {
                  networkDom.find('.network_Gateway').text('--');
                }
                if (subnet.substring(0, subnet.length - 1)) {
                  networkDom.find('.network_Subnet').text(subnet.substring(0, subnet.length - 1));
                  networkDom.find('.network_Subnet').attr('title', subnet.substring(0, subnet.length - 1));
                } else {
                  networkDom.find('.network_Subnet').text("--");
                }


              }

            }

            let authority = 'administrators'

            if (info.Portainer) {
              if (info.Portainer.ResourceControl.AdministratorsOnly) {
                authority = 'administrators';
              }
              if (info.Portainer.ResourceControl.Public) {
                authority = 'public';
              }
              if (!info.Portainer.ResourceControl.Public && !info.Portainer.ResourceControl.AdministratorsOnly) {
                authority = 'restricted';
              }
            }
            networkDom.find('.volume_authority').text(authority);

          }
          searchNetworkData('#jv-networksear');
          jQuery('#jv-pageList').html('');
          for (var p = 1; p <= obj.pages; p++) {
            var mi = document.createElement("li");
            jQuery(mi).text(p);
            jQuery('#jv-pageList').append(mi);

            mi.onclick = function() {
              initData.curr = jQuery(this).text();
              refreshInfo(data, count, initData.curr);
            }

          }
          $('#jv-pageitemList').children().each(function(i, e){
            e.onclick = function() {
              initData.limit = jQuery(e).text();
              refreshInfo(data, count, initData.curr);
            }
          })

        } else {
          $('#jv-volumeNull').show();
          $('#jv-footerPage').hide();
        }

        if (obj.pages >= 1  && obj.count) {
          $("#jv-paging").show();
          $('#jv-footerPage').show();
        } else {
          $("#jv-paging").hide();
          $('#jv-footerPage').hide();
        }
        //首次不执行
        if (!first) {
          refreshInfo(data, count, initData.curr);
        }
      }
    });
  });

}

//搜索
function searchNetworkData(e) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (e) {
    t = e;
  }
  let v = $(t).val().trim();
  $("#jv-d-tbodybox>div:contains(" + v + ")").show();
  $("#jv-d-tbodybox>div:not(:contains(" + v + "))").hide();
}


// 删除网络列表
function deleteNetworkItem() {

  var delete_time = null;
  if (!initData.checkCount) {
    $('#jv-checkboxAll').prop("checked", false);
    return;
  }

  if (initData.deleteName.length) {
    for (let i = 0; i < initData.deleteName.length; i++) {
      let obj = {
        url: '../api/endpoints/' + globalData.tty + '/docker/networks/' + initData.deleteName[i],
        type: 'DELETE'
      }

      postData(obj, {
        success: function(result) {

        },
        complete: function(xhr, textStatus) {
          initData.deleteName.splice(i, 1);
          initData.checkCount--;
        },
        error: function(xhr, textStatus) {
          console.log(xhr);
          console.log(textStatus);

        }
      });
    }
  }

  var t = setInterval(function() {
    if (!initData.checkCount) {
      inNetworls();
      clearInterval(t);
    }
  }, 50);

}

function inspectOvs() {
  if (!that.find('#jv-ovsOption').children().length) {
    errorMessageBox('没有可用ovs');
    return;
  }
  let data = {
    "token": getCookie('PHPSESSID') || "",
    "cmd": "docker_ovs_check",
    "params": {
      "ovs": that.find('#jv-ovsOption').val()
    }
  };
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      var ovsInfo = result.results;
      for (var v in ovsInfo) {
        if (ovsInfo.hasOwnProperty(v)) {
          for (var k in ovsInfo[v]) {
            if (ovsInfo[v].hasOwnProperty(k)) {

              if (k == 'IPRange') {
                var ip_range = getiprange(ovsInfo[v][k], that);
                that.find('#jv-IP-Range').text(ip_range);
              }
              that.find('#jv-' + v).find('input[nettype=' + k + ']').val(ovsInfo[v][k]);

            }
          }
        }
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}
// 全选
function checkboxAll() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  initData.checkCount = 0;
  initData.deleteName = [];
  if (t.checked) {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      if (e.disabled) {
        return;
      }
      e.checked = true;
      initData.deleteName.push($(e).data('dataInfo').Id)
    })
  } else {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = false;
      initData.deleteName = [];
    })
  }
  initData.checkCount = initData.deleteName.length;

}

// 单选
function checkboxSelect() {

  let event = window.event || arguments.callee.caller.arguments[0];
  let len = $('#jv-d-tbodybox').find('.jvc-checkbox').length;
  initData.checkCount = 0;
  initData.deleteName = [];
  $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
    if (e.checked) {
      initData.checkCount++;
      initData.deleteName.push($(e).data('dataInfo').Id);
    }
  })
  if (initData.checkCount == len) {
    $('#jv-checkboxAll').prop("checked", true);
  } else {
    $('#jv-checkboxAll').prop("checked", false);
  }

}

// 获取ovs列表
function getDockerOvs(that) {

  let data = {
    "token": getCookie('PHPSESSID') || "",
    "cmd": "docker_ovs"
  };
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      var ovs = result.results.ovs || [];
      if (result) {
        let dom = '';
        for (let i = 0; i < ovs.length; i++) {
          let info = ovs[i];
          dom += '<option value=' + info + '>' + info + '</option>';
        }
        that.find('#jv-ovsOption').append(dom);
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

//-------------------------
(function() {
  'use strict'

  $(document).ready(function() {
    inNetworls();

    let lang = localStorage.getItem('lang');
    changeLanguage(lang);

    getDockerOvs($('#jv-mainContent'));
  })

}())
