var time = null;
function setConfData(jsoninfo, info){

  var initConfData = {
    "Cmd": null,
    "Image": "",
    "Env": [],
    "ExposedPorts": {},
    "HostConfig": {
      "AutoRemove": false,
      "Binds": [],
      "Devices": [],
      "Dns": [],
      "PublishAllPorts": true,
      "PortBindings": {},
      "ExtraHosts": [],
      "RestartPolicy": {
        "Name": "no"
      },
      "Init": false,
      "Privileged": false,
      "Runtime": null,
      "NetworkMode": "bridge",
      "MemoryReservation": 0,
      "Memory": 0,
      "NanoCpus": 0,
      "CapAdd": [],
      "CapDrop": []
    },
    "NetworkingConfig": {
      "EndpointsConfig": {}
    },
    "Labels": {},
    "Volumes": {},
    "name": "",
    "OpenStdin": true,
    "Tty": true,
    "User": "",
    "Entrypoint": null,
    "WorkingDir": ""
  }

  let new_name = info.name;
  let container_num = 1;
  while (containerNameS.indexOf(new_name) > -1) {
    new_name = info.name + '_' + container_num;
    container_num++;
  }
  initConfData['name'] = new_name;
  initConfData.Env = jsoninfo.Config.Env;
  initConfData.User = jsoninfo.Config.User;
  initConfData.WorkingDir = jsoninfo.Config.WorkingDir;
  initConfData.Cmd = jsoninfo.Config.Cmd;
  initConfData.Entrypoint = jsoninfo.Config.Entrypoint;
  initConfData.Image = jsoninfo.Config.Image;
  initConfData.Labels = jsoninfo.Config.Labels;
  initConfData.Tty = jsoninfo.Config.Tty;
  initConfData.HostConfig.PublishAllPorts = jsoninfo.HostConfig.PublishAllPorts

  initConfData.HostConfig.ExtraHosts = jsoninfo.HostConfig.ExtraHosts
  initConfData.HostConfig.RestartPolicy = jsoninfo.HostConfig.RestartPolicy
  initConfData.HostConfig.Init = jsoninfo.HostConfig.Init
  initConfData.HostConfig.Privileged = jsoninfo.HostConfig.Privileged
  initConfData.HostConfig.Runtime = jsoninfo.HostConfig.Runtime

  initConfData.OpenStdin = jsoninfo.Config.OpenStdin;
  initConfData.HostConfig.CapAdd =  jsoninfo.HostConfig.CapAdd;
  initConfData.HostConfig.CapDrop =  jsoninfo.HostConfig.CapDrop;
  setNetwork(jsoninfo, initConfData);

  return initConfData;
}

function docker_install(conf, id, e, mounts = {}, ports = {}) {
  return new Promise(function(resolve, reject) {
    var data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_install",
      "params": {
        conf: conf,
        mounts: mounts,
        ports: ports,
        id: id
      }
    }

    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(res) {
        resolve(res.results);
        if (e) {
          var ti = $(e).data('dataInfo') || {};
          var size = ti.size;
          if (size != -1) {
            $(e).find('.jvc-installOp').hide();
            $(e).find('.jvc-installing').show();
          }else {
            $(e).find('.jvc-installOp').hide();
            $(e).find('.jvc-downloadop').show();
          }

          $(e).find('.jvc-checkbox').prop("checked", false).attr('disabled', true);
        }
        docker_installing($('#jv-d-tbodybox'));
      },
      complete: function() {
        if (!ckdom.length) {
          hideLoading();
        }
        closePopup();
        $('#jv-popup').hide();
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    }, false);
  })
}

function getContainerJson(id, st) {
  return new Promise(function(resolve, reject) {
    var data = {
      v: 1,
      act: 'json',
      param: {
        id: id
      }
    }

    let obj = {
      url: '/unas-docker/store/',
      data: JSON.stringify(data)
    }
    postData(obj, {
      success: function(res) {
        resolve(res.results);
        // st.data('dataInfo')['conf'] = res.results;
        // hideLoading();
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    }, false);
  })

}

function getContainerName() {
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/json?all=1',
    type: "get",
  }
  postData(obj, {
    success: function(result) {
      if (result) {
        for (var i = 0; i < result.length; i++) {
          var tp = result[i];
          let containerNamesStr = tp.Names ? tp.Names.toString() : "";
          if (containerNamesStr[0] == '/') {
            containerNamesStr = containerNamesStr.substr(1);
            containerNameS.push(containerNamesStr);
          }
        }
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}

function pullImage_shop(that) {

  var info = jQuery(that).data('dataInfo');
  var imageName = info.image;

  let data = {
    "token": getCookie('PHPSESSID') || "",
    "cmd": "docker_pull",
    "params": {
      "image": imageName,
      "action": "start"
    }
  }

  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      getImglist().then(function(imageS) {
        getUnasapp();
      });
    },
    complete: function() {
      hideLoading();
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

//提交创建容器数据
function submitContainerData(that, imagename) {
  let containerName = that.find("input[name='containerName']").val();
  let autoRemove = that.find("#jv-autoRemove").hasClass('open'); //自动删除
  let publishAllPorts = that.find("#jv-publishAllPorts").hasClass('open'); //同步主机开放端口
  let networkPortPublishingList = that.find('#jv-sdwldkHost').children();
  let networkPortPublishingData = manualNetworkPortPublishing(networkPortPublishingList); //手动网络端口发布

  var fromContainerData = {
    Image: imagename || that.find("#jv-myTag").val(),
    Env: [],
    ExposedPorts: networkPortPublishingData.exposedPorts,
    HostConfig: {
      AutoRemove: autoRemove, //自动删除
      Binds: [],
      Devices: [],
      Dns: [],
      PublishAllPorts: publishAllPorts, //同步主机开放端口
      PortBindings: networkPortPublishingData.portBindings,
      ExtraHosts: [],
      RestartPolicy: {
        Name: "no"
      },
      Init: false,
      Privileged: false,
      Runtime: null,
    },
    NetworkingConfig: {
      EndpointsConfig: {}
    },
    Labels: {},
    Volumes: {},
    name: containerName,
    OpenStdin: false,
    Tty: false,
  }


  setCommandLogging(that, fromContainerData);
  setVolumeBindData(that, fromContainerData);
  setNetworkData(that, fromContainerData);
  setEnvironmentVariablesData(that, fromContainerData);
  setLabelsData(that, fromContainerData);
  setRestartPolicyData(that, fromContainerData);
  setRuntimeResourcesData(that, fromContainerData);
  setCapabilitiesData(that, fromContainerData);

  return fromContainerData;
}


function docker_installing(target) {

  clearTimeout(time);
  return new Promise(function(resolve, reject) {
    var data = {
      "token": getCookie('PHPSESSID') || "",
      "cmd": "docker_installing"
    }
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }
    postData(obj, {
      success: function(res) {
        var info = res.results.installing || [];
        var progress = res.results.progress;
        resolve(info);
        if (info.length && target) {
          target.children().each(function(i, e) {
            var ti = $(e).data('dataInfo') || {};
            for (var i = 0; i < info.length; i++) {
              var id = info[i];
              var size = ti.size;
              var p = 0;
              if (id == ti.id) {
                if (size != -1) {
                  $(e).find('.jvc-installOp').hide();
                  $(e).find('.jvc-installing').show();
                  $(e).find('.jvc-installingloading').hide();
                  if (progress[id]) {
                    p = ((progress[id].download / size * 0.5) + (progress[id].extract / size * 0.45))*100;
                    if (p > 100) {
                      p = 100;
                    }
                    $(e).find('.jvc-bar-w').css('width', parseInt(p)+'%');
                    $(e).find('.jvc-bar-txt').text(parseInt(p)+'%');
                    $(e).find('.jvc-installingloading').hide();
                  }else {
                    $(e).find('.jvc-installing').hide();
                    $(e).find('.jvc-installingloading').show();
                  }

                }else {
                  $(e).find('.jvc-installOp').hide();
                  $(e).find('.jvc-downloadop').show();
                  $(e).find('.jvc-installingloading').hide();

                  if (progress[id]) {
                    $(e).find('.jvc-download').text(formSize(progress[id].download));
                    $(e).find('.jvc-installingloading').hide();
                  }else {
                    $(e).find('.jvc-downloadop').hide();
                    $(e).find('.jvc-installingloading').show();
                  }
                }
                $(e).find('.jvc-checkbox').prop("checked", false).attr('disabled', true);
                break;
              }else {

                $(e).find('.jvc-installOp').show();
                $(e).find('.jvc-installing').hide();
                $(e).find('.jvc-downloadop').hide();
                $(e).find('.jvc-installingloading').hide();
                $(e).find('.jvc-checkbox').attr('disabled', false);

              }
            }
          })

          time = setTimeout(function() {
            docker_installing(target)
          }, 3000);
        } else {
          clearTimeout(time);
          // $('#jv-d-tbodybox').find('.jvc-bar-w').css('width', '0%');
          // $('#jv-d-tbodybox').find('.jvc-bar-txt').text('0%');
          $('#jv-d-tbodybox').find('.jvc-installOp').show();
          $('#jv-d-tbodybox').find('.jvc-installing').hide();
          $('#jv-d-tbodybox').find('.jvc-downloadop').hide();
          $('#jv-d-tbodybox').find('.jvc-installingloading').hide();
          $('#jv-d-tbodybox').find('.jvc-checkbox').attr('disabled', false);
        }

        if (currentAppdetail) {
          setDownloadStatus(currentApp, currentAppdetail);
        }
      },
      complete: function() {

      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    }, false);
  })
}

function setDownloadStatus(currentApp, currentAppdetail){

  var bar_w = currentApp.find('.jvc-bar-txt').text();
  if (currentApp.find('.jvc-installOp').is(":visible")) {
    currentAppdetail.find('.jvc-installOp').show();
    currentAppdetail.find('.jvc-installing').hide();
    currentAppdetail.find('.jvc-downloadop').hide();
    currentAppdetail.find('.jvc-installingloading').hide();
  }else {
    if (currentApp.find('.jvc-downloadop').is(":visible")) {
      currentAppdetail.find('.jvc-installOp').hide();
      currentAppdetail.find('.jvc-installing').hide();
      currentAppdetail.find('.jvc-installingloading').hide();
      currentAppdetail.find('.jvc-downloadop').show();
      var dv = currentApp.find('.jvc-download').text();
      currentAppdetail.find('.jvc-download').text(dv);
    }else if (currentApp.find('.jvc-installing').is(":visible")) {
      currentAppdetail.find('.jvc-installOp').hide();
      currentAppdetail.find('.jvc-downloadop').hide();
      currentAppdetail.find('.jvc-installingloading').hide();
      currentAppdetail.find('.jvc-installing').show();
      currentAppdetail.find('.jvc-bar-txt').text(bar_w);
      currentAppdetail.find('.jvc-bar-w').css('width', bar_w);
    } else {
      currentAppdetail.find('.jvc-installOp').hide();
      currentAppdetail.find('.jvc-downloadop').hide();
      currentAppdetail.find('.jvc-installing').hide();
      currentAppdetail.find('.jvc-installingloading').show();
    }

  }


}
//创建卷
function createVolumes(name, path) {
  let ext = path.replace(/\//, '_');

  let data = {
    Driver: "local",
    DriverOpts: {},
    Name: name + '-' + ext
  }

  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/volumes/create',
      data: JSON.stringify(data)
    }

    postData(obj, {
      success: function(result) {
        resolve(result);
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}

//网络 ---------------------------------------------------------------------------------
function setNetwork(result, obj) {

  let extraHosts = result.HostConfig.ExtraHosts || [];
  let wlms = result.HostConfig.NetworkMode;
  let hostname = result.Config.Hostname;
  let domainname = result.Config.Domainname;
  let macaddress = result.Config.MacAddress;
  obj.HostConfig.Dns = result.HostConfig.Dns || [];
  result.HostConfig.Dns = result.HostConfig.Dns || [];
  let primarydnsserver = result.HostConfig.Dns[0];
  let secondarydnsserver = result.HostConfig.Dns[1];
  var ipv4address = '';
  var ipv6address = '';
  for (let networks in result.NetworkSettings) {
    if (result.NetworkSettings.hasOwnProperty(networks)) {
      if (networks == 'Networks') {
        for (var variable in result.NetworkSettings[networks]) {
          if (result.NetworkSettings[networks].hasOwnProperty(variable)) {
            for (var ipS in result.NetworkSettings[networks][variable]) {
              if (result.NetworkSettings[networks][variable].hasOwnProperty(ipS)) {
                if (ipS == 'IPAMConfig') {
                  if (result.NetworkSettings[networks][variable][ipS]) {
                    ipv4address = result.NetworkSettings[networks][variable][ipS].IPv4Address;
                    ipv6address = result.NetworkSettings[networks][variable][ipS].IPv6Address;
                  }
                }
              }
            }
          }
        }
      }
    }
  }


  if (hostname) {
    obj.Hostname = hostname;
  }
  if (domainname) {
    obj.Domainname = domainname;
  }
  if (macaddress) {
    obj.MacAddress = macaddress;
  }

  let dns = [],
    fv = [];
  if (primarydnsserver) {
    dns.push(primarydnsserver);
    obj.HostConfig.Dns = dns;
  }
  if (secondarydnsserver) {
    dns.push(secondarydnsserver);
    obj.HostConfig.Dns = dns;
  }

  for (let i = 0; i < extraHosts.length; i++) {
    fv.push(extraHosts[i]);
    obj.HostConfig.ExtraHosts = fv;
  }

  let networkModename = 'bridge'
  if (wlms) {
    networkModename = wlms;
  }


  obj.HostConfig.NetworkMode = wlms;

  let ipConfig = {
    IPAMConfig: {
      IPv4Address: '',
      IPv6Address: ''
    }
  }
  if (ipv4address) {
    ipConfig.IPAMConfig.IPv4Address = ipv4address;
  }
  if (ipv6address) {
    ipConfig.IPAMConfig.IPv6Address = ipv6address;
  }
  obj.NetworkingConfig.EndpointsConfig[networkModename] = ipConfig;

}

function classify(){
  let event = window.event || arguments.callee.caller.arguments[0];
  event.stopPropagation();
  $('#jv-classifylist').fadeToggle();

  jQuery('#jv-classifylist li').each(function(i, e) {
    e.onclick = function(ev) {
      ev.stopPropagation();
      var type = jQuery(this).attr("type");
      jQuery(this).attr('class', 'nav_on').siblings().removeClass('nav_on');

      refreshInfo(appAssort[type], appAssort[type].length, 1);
    }
  })


  $(document).on('click', function(e){
    e.stopPropagation();
    $('#jv-classifylist').fadeOut();
  })
}
