// 查看日志详情
var that_log = null;
var termLog = new Terminal({
  windowsMode: true
});

function logDetails(id) {
  that_log = showModel({
    title: '<span data-lang="containerlogs">日志详情</span>',
    oemplateName: 'jvt-logDetails',
    id: 'jv-logDetails',
    isShowApplicationBtn: false,
    isShowFooterBtn: false
  }, function(e) {

  })

  if (that_log.find('#jv-isShowTimestamps').hasClass('open')) {
    logPsotData.timestamps = 1;
  } else {
    logPsotData.timestamps = 0;
  }

  initData.containsId = id;
  getLog(id, logPsotData);
  window.containersLognIterval = setInterval(function() {
    getLog(id, logPsotData);
  }, 3000);
}

function getLog(id, data) {

  data.tail = that_log.find('.jvc-logLines').val();

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/logs',
    type: 'get',
    data: data
  }
  postData(obj, {
    success: function(result) {

    },
    complete: function(event, xhr, options) {
      if (event.status == 200) {
        that_log.find('#jv-contentLog').empty();
        termLog.open(that_log.find('#jv-contentLog')[0]);
        termLog.reset();
        termLog.write(event.responseText ? event.responseText.replace(/\n/g, "\r\n") : 'No logs available');
        that_log.find('.logDetailsContentList').data('data-text', event.responseText ? event.responseText :'No logs available');
        var height = that_log.find('.logDetailsContentList')[0].scrollHeight;
        that_log.find('.logDetailsContentList').scrollTop(height);
      }

    },
    error: function(xhr, textStatus) {

    }
  }, false);
}

//自动刷新日志
function autoRefreshLogs(t) {
  switchControl(t);
  that_log.find('.jvcLogDetailsControlswitch').slideToggle('show');
  if ($(t).hasClass('open')) {
    window.containersLognIterval = setInterval(function() {
      getLog(initData.containsId, logPsotData);
    }, 3000);
  } else {
    clearInterval(window.containersLognIterval);
  }
}
//换行
function wrapLines(t) {
  switchControl(t);
  if ($(t).hasClass('open')) {
    that_log.find('#jv-contentLog').removeClass('wrapLines');
  } else {
    that_log.find('#jv-contentLog').addClass('wrapLines');
  }
}
//显示时间戳:
function displayTimestamps(t) {
  switchControl(t);
  if ($(t).hasClass('open')) {
    logPsotData.timestamps = 1;
  } else {
    logPsotData.timestamps = 0;
  }
}

function setLimits(type) {
  let n = that_log.find('.jvc-logLines').val();
  switch (type) {
    case 'increase':
      n++;
      that_log.find('.jvc-logLines').val(n);
      break;
    case 'reduce':
      n--;
      that_log.find('.jvc-logLines').val(n);
      break;
    default:

  }
}
//设置日志查看时间
function setSince() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  var timestamp = Date.parse(new Date()) / 1000;
  if (v == 0) {
    timestamp = 0
  } else {
    if (v == 10) {
      timestamp = timestamp - v * 60;
    } else {
      timestamp = timestamp - v * 60 * 60;
    }
  }

  logPsotData.since = timestamp;
  getLog(initData.containsId, logPsotData);
}

//检查  checkContainer.checkContainer
function checkContainer(id) {

  let that = showModel({
    title: '<span data-lang="containerinspect">检查</span>',
    oemplateName: 'jvt-checkContainer',
    id: 'jv-checkContainer',
    isShowApplicationBtn: false,
    isShowFooterBtn: false

  }, function(e) {

  })
  let strText = {};

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/containers/' + id + '/json',
    type: 'get'
  }
  postData(obj, {
    success: function(result) {},
    complete: function(event, xhr, options) {
      if (event.status == 200) {

        strText = event.responseText;
        that.find('#jv-logDetailsContentList .text').jsonViewer(JSON.parse(event.responseText), '');

      }
    },
    error: function(xhr, textStatus) {

    }
  });

  that.find('.topNavBtnList .navBtnItem').click(function(e) {
    $(this).addClass('selectnavBtnItem').siblings().removeClass('selectnavBtnItem');
    if ($(this).attr('data-type') == 'tree') {
      let t = JSON.parse(strText);
      that.find('#jv-logDetailsContentList .text').jsonViewer(t, '');
    } else {
      that.find('#jv-logDetailsContentList .text').html(prettyFormat(strText));
    }

  })


}

//json格式美化
function prettyFormat(str) {
  try {
    // 设置缩进为2个空格
    str = JSON.stringify(JSON.parse(str), null, 2);
    str = str
      .replace(/&/g, '&amp;')
      .replace(/</g, '&lt;')
      .replace(/>/g, '&gt;');
    return str.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function(match) {
      var cls = 'number';
      if (/^"/.test(match)) {
        if (/:$/.test(match)) {
          cls = 'key';
        } else {
          cls = 'string';
        }
      } else if (/true|false/.test(match)) {
        cls = 'boolean';
      } else if (/null/.test(match)) {
        cls = 'null';
      }
      return '<span class="' + cls + '">' + match + '</span>';
    });
  } catch (e) {
    alert("异常信息:" + e);
  }
}


function copyLog() {
  copyText(that_log.find('.logDetailsContentList').data('data-text'));
}

function copyText(text) {
  var textarea = document.createElement("textarea"); //创建input对象
  var currentFocus = document.activeElement; //当前获得焦点的元素
  document.body.appendChild(textarea); //添加元素
  textarea.value = text;
  textarea.focus();
  if (textarea.setSelectionRange)
    textarea.setSelectionRange(0, textarea.value.length); //获取光标起始位置到结束位置
  else
    textarea.select();
  try {
    var flag = document.execCommand("copy"); //执行复制
  } catch (eo) {
    var flag = false;
  }
  document.body.removeChild(textarea); //删除元素
  currentFocus.focus();
  return flag;
}
