SPA_RESOLVE_INIT = function(transition) {}

SPA_RESOLVE_HTML = function(transition) {}

var imagesSourceData = {
  list: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: localStorage.getItem('limit_reg') || 10, //每页数量
  checkCount: 0, //已选列表数量
  deleteName: [], //保存删除列表名称
}

var that_imagesSource = null;

function addImagesSource() {
  that_imagesSource = showModel({
    title: '<span data-lang="addRegistries">添加镜像源</span>',
    oemplateName: 'jvt-imagesSource',
    id: 'jv-imagesSource',
    isShowApplicationBtn: false,
    isShowFooterBtn: true

  }, function(e) {
    if (e) {
      addRegistries();
    }
  })
}

//添加镜像源
function addRegistries() {
  let name = that_imagesSource.find('#jv-Name').val();
  let url = that_imagesSource.find('#jv-URL').val();
  let username = that_imagesSource.find('#jv-Username').val();
  let password = that_imagesSource.find('#jv-Password').val();
  let authentication = that_imagesSource.find('#jv-Authentication').attr('authentication') == 'false' ? false : true;

  if (url.indexOf("http://") != -1) {
    url = url.substring(7);
  }
  if (url.indexOf("https://") != -1) {
    url = url.substring(8);
  }
  let data = {
    'Authentication': authentication,
    'Type': 3,
  }

  if (!name || !url) {
    errorMessageBox('所有字段必填');
    return;
  } else {
    data['Name'] = name;
    data['URL'] = url;
  }
  if (authentication) {
    if (!username || !password) {
      errorMessageBox('所有字段必填');
      return;
    }
    data['Password'] = password;
    data['Username'] = username;
  }

  var addData = {
    cmd : 'docker_registry_add',
    params : data
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(addData)
  }

  postData(obj, {
    success: function(result) {
      if (result) {
        getRegistriesList();
        closePopup();
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}

// 获取镜像源列表
function getRegistriesList() {
  var data = {
    cmd : 'docker_registry_list'
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(res) {
      var result = res.results || [];
      $('#jv-d-tbodybox').empty();
      $('#jv-checkboxAll').prop("checked", false);
      if (result.length) {
        var len = result.length;
        imagesSourceData.volumes = result;
        imagesSourceData.count = result.length;
        refreshImagesSourceInfo(result, imagesSourceData.count, imagesSourceData.curr);

        $('#jv-volumeNull').hide();
      } else {
        $('#jv-volumeNull').show();
        $('#jv-footerPage').hide();
      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

// 设置Authentication
function setAuthentication(t) {
  if ($(t).hasClass('open')) {
    that_imagesSource.find('#jv-authenticationNr').slideDown();
    $(t).attr('authentication', true);
  } else {
    that_imagesSource.find('#jv-authenticationNr').slideUp();
    $(t).attr('authentication', false);
  }
}

function deleteRegistriesItem(id) {

  var data = {
    cmd : 'docker_registry_rm',
    params : {
      Id : id
    }
  }
  let obj = {
    url: '../../unas-docker/includes/index.php',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      getRegistriesList();
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });
}

function deleteRegistriesS(id) {

  return new Promise(function(resolve, reject) {
    var data = {
      cmd : 'docker_registry_rm',
      params : {
        Id : id
      }
    }
    let obj = {
      url: '../../unas-docker/includes/index.php',
      data: JSON.stringify(data)
    }
    postData(obj, {
      success: function(result) {
        resolve(result);
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })

}

function deleteImagesSourceOP() {
  var i = imagesSourceData.deleteName.length;
  if (!i) {
    return;
  }
  deleteRegistriesS(imagesSourceData.deleteName[0]).then(function(res) {
    imagesSourceData.deleteName.splice(0, 1);
    if (imagesSourceData.deleteName.length) {
      deleteImagesSourceOP();
    } else {
      getRegistriesList();
    }
  });
}
//数据更新
function refreshImagesSourceInfo(volumes, count, curr) {

  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: imagesSourceData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        imagesSourceData.curr = obj.curr; //得到当前页，以便向服务端请求对应页的数据。
        $('#jv-gopage').text(obj.curr);
        $('#jv-pageitemV').text(imagesSourceData.limit);
        let t = arrTrans(imagesSourceData.limit, volumes);
        $('#jv-d-tbodybox').empty();
        if (volumes.length) {
          var len = t[imagesSourceData.curr - 1].length;
          for (var i = 0; i < len; i++) {
            let info = t[imagesSourceData.curr - 1][i];
            var networkDom = wfTemplateAppend('#jv-d-tbodybox', 'jvt-d-tr', 'jvt-d-tr' + i);
            networkDom.find('.register_Name').text(info.Name);
            networkDom.find('.register_URL').text(info.URL);
            networkDom.find('.jvc-checkbox').data('imagesSourceInfo', info);
            networkDom.find('.register_Actions').attr('onclick', 'deleteRegistriesItem(' + info.Id + ')');
          }

          jQuery('#jv-pageList').html('');
          for (var p = 1; p <= obj.pages; p++) {
            var mi = document.createElement("li");
            jQuery(mi).text(p);
            jQuery('#jv-pageList').append(mi);

            mi.onclick = function() {
              imagesSourceData.curr = jQuery(this).text();
              refreshImagesSourceInfo(volumes, count, imagesSourceData.curr);
            }

          }
          $('#jv-pageitemList').children().each(function(i, e){
            e.onclick = function() {
              imagesSourceData.limit = jQuery(e).text();
              refreshImagesSourceInfo(volumes, count, imagesSourceData.curr);
              localStorage.setItem('limit_reg', jQuery(e).text());
            }
          })

        } else {
          $('#jv-volumeNull').show();
          $('#jv-footerPage').hide();
        }

        if (obj.pages >= 1) {
          $("#jv-paging").show();
          $('#jv-footerPage').show();
        } else {
          $("#jv-paging").hide();
          $('#jv-footerPage').hide();
        }
        //首次不执行
        if (!first) {
          refreshImagesSourceInfo(volumes, count, imagesSourceData.curr);
        }
      }
    });
  });

}

// 全选
function checkboxAll() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  imagesSourceData.checkCount = 0;
  imagesSourceData.deleteName = [];
  if (t.checked) {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = true;
      imagesSourceData.deleteName.push($(e).data('imagesSourceInfo').Id)
    })
  } else {
    $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = false;
      imagesSourceData.deleteName = [];
    })
  }
  imagesSourceData.checkCount = imagesSourceData.deleteName.length;
}

// 单选
function checkboxSelect() {

  let event = window.event || arguments.callee.caller.arguments[0];
  let len = $('#jv-d-tbodybox').find('.jvc-checkbox').length;
  imagesSourceData.checkCount = 0;
  imagesSourceData.deleteName = [];
  $('#jv-d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
    if (e.checked) {
      imagesSourceData.checkCount++;
      imagesSourceData.deleteName.push($(e).data('imagesSourceInfo').Id);
    }
  })
  if (imagesSourceData.checkCount == len) {
    $('#jv-checkboxAll').prop("checked", true);
  } else {
    $('#jv-checkboxAll').prop("checked", false);
  }

}


(function() {
  'use strict'

  $(document).ready(function() {
    getRegistriesList();
  })


  $('body').on('click', '.navckItem', function(e) {
    let t = $(e.currentTarget);
    t.addClass('currentNavckItem').siblings().removeClass('currentNavckItem');
  })

  let lang = localStorage.getItem('lang');
  changeLanguage(lang);

}())
