SPA_RESOLVE_INIT = function(transition) {}

SPA_RESOLVE_HTML = function(transition) {}

var volumeData = {
  volumes: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: localStorage.getItem('limit_vol') || 10, //每页数量
  checkCount: 0, //已选列表数量
  deleteName: [], //保存删除列表名称
}
var that = null;

function getContainers() {
  return new Promise(function(resolve, reject){
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/containers/json?all=1',
      type: "get",
    }
    postData(obj, {
      success: function(result) {
        resolve(result);
      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);
      }
    });
  })
}

// 获取数据卷列表
function inVolume() {

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/volumes',
    type: "get"
  }

  postData(obj, {
    success: function(result) {
      if (result) {
        getContainers().then(function(res){
          var containers = [];
          for (var i = 0; i < res.length; i++) {
            var info = res[i];
            for (var j = 0; j < info.Mounts.length; j++) {
              var mounts = info.Mounts[j];
              if (mounts.Type == "volume") {
                var name = info.Names ? info.Names.toString() : "";
                if (name[0] == '/') {
                  name = name.substr(1);
                }
                info.Mounts[j]['containername'] = name;
              }
            }
          }

          for (var k = 0; k < result.Volumes.length; k++) {
            var vol = result.Volumes[k];
            for (var h = 0; h < res.length; h++) {
              for (var z = 0; z < res[h].Mounts.length; z++) {
                if (res[h].Mounts[z].Name == vol.Name) {
                  vol['containername'] = res[h].Mounts[z].containername;
                }
              }
            }
          }

          volumeData.volumes = result.Volumes;
          volumeData.count = result.Volumes.length;
          $('#jv-checkboxAll').prop("checked", false);

          refreshInfo(result.Volumes, volumeData.count, volumeData.curr);
        })

      }

    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });

}

//数据更新
function refreshInfo(volumes, count, curr) {

  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: volumeData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        volumeData.curr = obj.curr; //得到当前页，以便向服务端请求对应页的数据。
        $('#jv-gopage').text(obj.curr);
        $('#jv-pageitemV').text(volumeData.limit);
        let t = arrTrans(volumeData.limit, volumes);
        $('#d-tbodybox').empty();
        if (volumes.length) {
          var len = t[volumeData.curr - 1].length;
          for (var i = 0; i < len; i++) {
            let info = t[volumeData.curr - 1][i];
            var volumeDom = wfTemplateAppend('#d-tbodybox', 'jvt-dtr', 'jvt-dtr' + i);
            volumeDom.find('.jvc-checkbox').data('volumeInfo', info);
            volumeDom.find('.volumeName').text(info.Name);
            volumeDom.find('.volume_stack').text('--');
            volumeDom.find('.containername').text(info.containername || '--');
            volumeDom.find('.volume_Driver').text(info.Driver).attr('class', 'volume_Driver ' + info.Driver);
            volumeDom.find('.volume_Mountpoint').text(info.Mountpoint).attr('title',info.Mountpoint);
            volumeDom.find('.volume_CreatedAt').text(formatDate(new Date(info.CreatedAt).getTime()));

            volumeDom.find('.volume_Actions').attr('onclick', 'deleteVolumeItem("' + info.Name + '")');

            let authority = 'administrators'

            if (info.Portainer) {
              if (info.Portainer.ResourceControl.AdministratorsOnly) {
                authority = 'administrators';
              }
              if (info.Portainer.ResourceControl.Public) {
                authority = 'public';
              }
              if (!info.Portainer.ResourceControl.Public && !info.Portainer.ResourceControl.AdministratorsOnly) {
                authority = 'restricted';
              }
            }
            volumeDom.find('.volume_authority').text(authority);

          }

          jQuery('#jv-pageList').html('');
          for (var p = 1; p <= obj.pages; p++) {
            var mi = document.createElement("li");
            jQuery(mi).text(p);
            jQuery('#jv-pageList').append(mi);

            mi.onclick = function() {
              volumeData.curr = jQuery(this).text();
              refreshInfo(volumes, count, volumeData.curr);
            }

          }
          $('#jv-pageitemList').children().each(function(i, e){
            e.onclick = function() {
              volumeData.limit = jQuery(e).text();
              refreshInfo(volumes, count, volumeData.curr);
              localStorage.setItem('limit_vol', jQuery(e).text());
            }
          })
          searVolData("#jv-volsear");
        } else {
          $('#jv-volumeNull').show();
          $('#jv-footerPage').hide();
        }

        if (obj.pages >= 1 && obj.count) {
          $("#jv-paging").show();
          $('#jv-footerPage').show();
        } else {
          $("#jv-paging").hide();
          $('#jv-footerPage').hide();
        }
        //首次不执行
        if (!first) {
          refreshInfo(volumes, count, volumeData.curr);
        }
      }
    });
  });

}

//添加驱动程序
function addDriverOption() {
  let len = that.find('#jv-driverOptionHost').children().length;
  var volumeDom = wfTemplateAppend(that.find('#jv-driverOptionHost'), 'jvt-DriverOptionItem', 'jvt-DriverOptionItem' + len);
}
//删除驱动程序
function deleteDriverOption() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  $(t).parent().remove();
}

//选择驱动程序
function selectControl() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  let v = $(t).val();
  that.find('.driverOptionItem').each(function(i, e) {
    that.find('#jv-' + v).show().siblings('.driverOptionItem').hide();
  })

}


//添加卷弹窗
function addVolume() {
  var t = showModel({
    title: '<span data-lang="createVolume">创建数据卷</span>',
    oemplateName: 'jvt-createVolume',
    id: 'jv-createVolume',
    isShowApplicationBtn: false,
    isShowFooterBtn: true

  }, function(e) {
    if (e) {
      let data = {
        Driver: t.find('#jv-selectControl option:selected').val(),
        DriverOpts: {},
        Name: t.find('#jv-volumeName').val()
      }

      switch (t.find('#jv-selectControl').val()) {
        case 'local':
          t.find('#jv-driverOptionHost').children().each(function(i, e) {
            let field = $(e).find("input[name='name']").val();
            let val = $(e).find("input[name='value']").val();
            data.DriverOpts[field] = val;
          })
          break;
        case 'nfs':
          let nfs = t.find('#jv-nfs');
          let nfs_address = nfs.find("input[name='address']").val();
          let nfs_device = nfs.find("input[name='point']").val();
          let options = nfs.find("input[name='options']").val();
          let nfsvers = nfs.find('.selectControl option:selected').val();
          let nfs_o = '';
          if (nfsvers == 'NFS4') {
            nfs_o = 'addr=' + nfs_address + ',' + options + ',' + 'nfsvers=4';
          } else {
            nfs_o = 'addr=' + nfs_address + ',' + options;
          }
          if (!nfs_address || !nfs_device || !options) {
            errorMessageBox('所有字段必填');
            return;
          }

          data.DriverOpts['device'] = ':' + nfs_device;
          data.DriverOpts['o'] = nfs_o;
          data.DriverOpts['type'] = 'nfs';
          break;
        case 'cifs':
          let cifs = t.find('#jv-cifs');
          let cifs_address = cifs.find("input[name='address']").val();
          let share = cifs.find("input[name='share']").val();
          let cifs_device = '//' + cifs_address + '/' + share;

          let username = cifs.find("input[name='username']").val();
          let password = cifs.find("input[name='password']").val();
          let vers = cifs.find('.selectControl option:selected').attr('data-v');
          let cifs_o = 'username=' + username + ',' + 'password=' + password + ',' + 'vers=' + vers;
          if (!cifs_address || !share || !username || !password) {
            errorMessageBox('所有字段必填');
            return;
          }

          data.DriverOpts['device'] = cifs_device;
          data.DriverOpts['o'] = cifs_o;
          data.DriverOpts['type'] = 'cifs';

          break;
        default:

      }

      if (!t.find('#jv-volumeName').val()) {
        errorMessageBox('所有字段必填');
        return;
      }

      createVolumes(data);
    }
  })
  that = t;
}

//确认添加卷
function createVolumes(data) {

  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/volumes/create',
    data: JSON.stringify(data)
  }

  postData(obj, {
    success: function(result) {
      if (result) {
        closePopup();
        inVolume();
      }
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);
    }
  });

}

// 删除数据卷列表
function deleteVolumeS(name) {

  return new Promise(function(resolve, reject) {
    let obj = {
      url: '../api/endpoints/' + globalData.tty + '/docker/volumes/' + name,
      type: 'DELETE'
    }
    postData(obj, {
      success: function(result) {
        resolve(result);
      },
      complete: function(xhr, textStatus) {

      },
      error: function(xhr, textStatus) {
        console.log(xhr);
        console.log(textStatus);

      }
    });
  })

}

function deleteVolumeOP() {
  var i = volumeData.deleteName.length;
  if (!i) {
    return;
  }
  deleteVolumeS(volumeData.deleteName[0]).then(function(res) {
    volumeData.deleteName.splice(0, 1);
    volumeData.checkCount--;
    if (volumeData.deleteName.length) {
      deleteVolumeOP();
    } else {
      inVolume();
    }
  });
}

function deleteVolumeItem(name){
  let obj = {
    url: '../api/endpoints/' + globalData.tty + '/docker/volumes/' + name,
    type: 'DELETE'
  }

  postData(obj, {
    success: function(result) {
    },
    complete: function(xhr, textStatus) {
      inVolume();
    },
    error: function(xhr, textStatus) {
      console.log(xhr);
      console.log(textStatus);

    }
  });
}
// 全选
function checkboxAll() {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  volumeData.checkCount = 0;
  volumeData.deleteName = [];
  if (t.checked) {
    $('#d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = true;
      volumeData.deleteName.push($(e).data('volumeInfo').Name)
    })
  } else {
    $('#d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
      e.checked = false;
      volumeData.deleteName = [];
    })
  }
  volumeData.checkCount = volumeData.deleteName.length;
}

// 单选
function checkboxSelect() {

  let event = window.event || arguments.callee.caller.arguments[0];
  let len = $('#d-tbodybox').find('.jvc-checkbox').length;
  volumeData.checkCount = 0;
  volumeData.deleteName = [];
  $('#d-tbodybox').find('.jvc-checkbox').each(function(i, e) {
    if (e.checked) {
      volumeData.checkCount++;
      volumeData.deleteName.push($(e).data('volumeInfo').Name);
    }
  })
  if (volumeData.checkCount == len) {
    $('#jv-checkboxAll').prop("checked", true);
  } else {
    $('#jv-checkboxAll').prop("checked", false);
  }

}

function searVolData(e) {
  let event = window.event || arguments.callee.caller.arguments[0];
  let t = event.target;
  if (e) {
    t = e;
  }
  let v = $(t).val().trim();
  $("#d-tbodybox>div:contains(" + v + ")").show();
  $("#d-tbodybox>div:not(:contains(" + v + "))").hide();

}

(function() {
  'use strict'

  window.volumeInterval = setInterval('inVolume()', 20000);

  $(document).ready(function() {
    inVolume();
  })

  let lang = localStorage.getItem('lang');
  changeLanguage(lang);

}())
