#!/usr/bin/python3

from shutil import copy
from genericpath import isfile
import os
import sys
import json

target_container_dir = "/var/lib/docker/containers/"+sys.argv[1]+"/"
tmp_container_dir = "/var/lib/docker/containers/"+sys.argv[2]+"/"
container_name = sys.argv[3]

def cover_normal_files():
    copy_file_list = ["hostconfig.json", "hostname", "hosts", "resolv.conf", "resolv.conf.hash"]

    for file in copy_file_list:
        if isfile(tmp_container_dir + file):
            copy(tmp_container_dir + file, target_container_dir + file)
        elif isfile(target_container_dir + file):
            os.unlink(target_container_dir + file)

def cover_config():
    unique_items = [ "ID", "LogPath", "HostnamePath", "HostsPath", "ResolvConfPath" ];
    with open(target_container_dir + "config.v2.json", 'r') as old_config_file:
        old_config = json.load(old_config_file)
    with open(tmp_container_dir + "config.v2.json", 'r') as tmp_config_file:
        tmp_config = json.load(tmp_config_file)

    for item in unique_items:
        tmp_config[item] = old_config[item]

    tmp_config["Name"] = "/"+container_name

    with open(target_container_dir + "config.v2.json", 'w') as target_config_file:
        json.dump(tmp_config, target_config_file)

def main():
    """ Main processor
    """
    cover_normal_files()
    cover_config()

if __name__ == "__main__":
    main()
